﻿/// <reference path="/files/js/jquery.min.js" />
/// <reference path="/files/js/jquery.ui.min.js" />


function _pm_init() {
    var dclist = $.parseJSON('$dclist');
    var oslist = $.parseJSON('$oslist');
    var productConfig = $("#ProductConfig");
    var cpu = productData[0].pconfig.cpu == undefined ? '2' : productData[0].pconfig.cpu;
    var config_ram_max = productData[0].pconfig.ram == undefined ? '512' : productData[0].pconfig.ram;
    var config_ram_min = productData[0].pconfig.ram_min == undefined ? config_ram_max : productData[0].pconfig.ram_min;
    config_ram_max = productData[0].pconfig.ram_max == undefined ? config_ram_max : productData[0].pconfig.ram_max;

    var disk = productData[0].pconfig.disk == undefined ? '20' : productData[0].pconfig.disk;
    var bw = productData[0].pconfig.bw == undefined ? '0' : productData[0].pconfig.bw;
    var port = productData[0].pconfig.port == undefined ? '0' : productData[0].pconfig.port;
    var ipc = productData[0].pconfig.ipc == undefined ? '1' : productData[0].pconfig.ipc;
    var snapshot = productData[0].pconfig.snapshot == undefined ? '0' : productData[0].pconfig.snapshot;
    var full_backup = productData[0].pconfig.full_backup == undefined ? '0' : productData[0].pconfig.full_backup;
    var domain = productData[0].pconfig.domain == undefined ? '0' : productData[0].pconfig.domain;
    var portmap = productData[0].pconfig.portmap == undefined ? '0' : productData[0].pconfig.portmap;

    var cpu_step = productData[0].pupgrade.cpu_step == undefined ? '1' : productData[0].pupgrade.cpu_step;
    var ram_step = productData[0].pupgrade.ram_step == undefined ? '32' : productData[0].pupgrade.ram_step;
    var disk_step = productData[0].pupgrade.disk_step == undefined ? '1' : productData[0].pupgrade.disk_step;
    var bw_step = productData[0].pupgrade.bw_step == undefined ? '10' : productData[0].pupgrade.bw_step;
    var port_step = productData[0].pupgrade.port_step == undefined ? '1' : productData[0].pupgrade.port_step;

    var cpu_price = productData[0].pupgrade.cpu_price == undefined ? '5' : productData[0].pupgrade.cpu_price;
    var ram_price = productData[0].pupgrade.ram_price == undefined ? '5' : productData[0].pupgrade.ram_price;
    var disk_price = productData[0].pupgrade.disk_price == undefined ? '1' : productData[0].pupgrade.disk_price;
    var bw_price = productData[0].pupgrade.bw_price == undefined ? '1' : productData[0].pupgrade.bw_price;
    var port_price = productData[0].pupgrade.port_price == undefined ? '10' : productData[0].pupgrade.port_price;

    var cpu_max = productData[0].pupgrade.cpu_max == undefined ? '8' : productData[0].pupgrade.cpu_max;
    var ram_max = productData[0].pupgrade.ram_max == undefined ? '2048' : productData[0].pupgrade.ram_max;
    var disk_max = productData[0].pupgrade.disk_max == undefined ? '200' : productData[0].pupgrade.disk_max;
    var bw_max = productData[0].pupgrade.bw_max == undefined ? '100000' : productData[0].pupgrade.bw_max;
    var port_max = productData[0].pupgrade.port_max == undefined ? '100' : productData[0].pupgrade.port_max;

    var ip = productData[0].pupgrade.ip == undefined ? '10' : productData[0].pupgrade.ip;
    var ip_max = productData[0].pupgrade.ip_max == undefined ? '5' : productData[0].pupgrade.ip_max;

    var snapshot_price = productData[0].pupgrade.snapshot_price == undefined ? '10' : productData[0].pupgrade.snapshot_price;
    var snapshot_max = productData[0].pupgrade.snapshot_max == undefined ? '3' : productData[0].pupgrade.snapshot_max;
    var full_backup_price = productData[0].pupgrade.full_backup_price == undefined ? '20' : productData[0].pupgrade.full_backup_price;
    var full_backup_max = productData[0].pupgrade.full_backup_max == undefined ? '2' : productData[0].pupgrade.full_backup_max;

    var serviceName = productData[0].pconfig.serviceName == undefined ? '[cpu] CPUs, [ram]M Ram, [disk]G Disk, [ip], [os]' : productData[0].pconfig.serviceName;
    var str = '<div><h3><strong>云主机产品基本参数配置</strong></h3><div style="line-height:31px">' +
              '<strong>产品服务名称格式</strong>：<input class="text" style="width:350px" name="config_serviceName" value="' + serviceName + '"/> 用户服务列表中的标题格式 <a href="https://my.cloudgoing.com/go.aspx?id=10015" target="_blank">[查看规则教程]</a><br / >' +
              '<div id="xsBaseConfig"><strong>主机基础套餐配置</strong>：<br / >' +
              '<strong>核心配置</strong>：<input class="text center" name="config_cpu" value="' + cpu + '" style="width:50px"/> CPUs' +
                                         '<span style="padding-left:35px">内存：</span><input class="text center" name="config_ram_min" style="width:50px" value="' + config_ram_min + '" title="最小可用内存，当小于最大可用内存时启用动态内存分配，反之则使用静态内存分配"/> ~ <input class="text center" name="config_ram_max" style="width:50px" value="' + config_ram_max + '" title="最大可用内存"/>MB' +
                                         '<span style="padding-left:30px">硬盘：</span><input class="text center" name="config_disk" style="width:50px" value="' + disk + '"/> GB<br />' +
              '<strong>网络配置</strong>：<input class="text center" name="config_ipc" value="' + ipc + '" style="width:50px"/> 个IP地址' +
                                         '<span style="padding-left:17px">端口：</span><input class="text center" name="config_port" style="width:50px" value="' + port + '"/> Mbps(0为不限)' +
                                         '<span style="padding-left:30px">流量：</span><input class="text center" name="config_bw" style="width:50px" value="' + bw + '"/> GB(0为不限)/月<br />' +
              '<strong>备份设置</strong>：<input class="text center" name="config_snapshot" value="' + snapshot + '" style="width:50px"/> 个快照备份 <input class="text center" name="config_full_backup" value="' + full_backup + '" style="width:50px;margin-left:37px"/> 个完整备份<br />' +
              '<strong>共享ＩＰ</strong>：<label><input type="checkbox" name="config_shareip" value="1" ' + (productData[0].pconfig.shareip == '1' ? 'checked="checked"' : '') + '/>使用共享IP</label>' +
                                         '<span style="padding-left:29px">可映射：</span><input class="text" name="config_portmap" value="' + portmap + '"/> 个端口' +
                                         '<span style="padding-left:67px">可绑定：</span><input class="text" name="config_domain" value="' + domain + '"/> 个域名' +
              '</div></div></div>' +
              '<div><h3><strong>服务器资源与操作系统配置</strong></h3><div style="line-height:31px">' +
              '<table><tr><td style="width:288px;"><strong>允许使用的服务器节点分组：</strong><select name="config_servergroup" multiple="multiple" style="width:258px;height:150px;"><option value="0" selected="selected">所有资源服务器组</option></select><br />（按住Ctrl可多选）</td>' +
              '<td style="width:288px;"><strong>允许安装的操作系统列表：</strong><select name="config_allowos" multiple="multiple" style="width:258px;height:150px;"><option value="0" selected="selected">所有操作系统</option></select><br />（按住Ctrl可多选）</td>' +
              '</tr></table>' +
              '</div></div>' +
              '<div><h3><strong>云主机在线升级参数配置</strong></h3><div style="line-height:31px" id="xsUpgradeConfig">' +
              '<strong>计费周期：</strong>/' + swin.find("input[name='sconfig_time_cycle']:checked").parent().text() + '<br />' +
              '<strong>cpu</strong>：每增加<input  class="text" name="upgrade_cpu_step" value="' + cpu_step + '"/>CPU &nbsp;<input class="text" name="upgrade_cpu_price" value="' + cpu_price + '"/>元，最多<input class="text" name="upgrade_cpu_max" value="' + cpu_max + '"/>cpu' +
              '<strong style="padding-left:25px">内存</strong>：每增加<input  class="text" name="upgrade_ram_step" value="' + ram_step + '"/>MB <input class="text" name="upgrade_ram_price" value="' + ram_price + '"/>元，最多<input class="text" name="upgrade_ram_max" value="' + ram_max + '"/>MB<br />' +
              '<strong>硬盘</strong>：每增加<input  class="text" name="upgrade_disk_step" value="' + disk_step + '"/>GB&nbsp;&nbsp;&nbsp;&nbsp;<input  class="text" name="upgrade_disk_price" value="' + disk_price + '"/>元，最多<input class="text" name="upgrade_disk_max" value="' + disk_max + '"/>GB' +
              '<strong style="padding-left:25px">流量</strong>：每增加<input  class="text" name="upgrade_bw_step" value="' + bw_step + '"/>GB <input  class="text" name="upgrade_bw_price" value="' + bw_price + '"/>元，最多<input  class="text" name="upgrade_bw_max" value="' + bw_max + '"/>GB<br />' +
              '<strong>端口</strong>：每增加<input  class="text" name="upgrade_port_step" value="' + port_step + '"/>Mb&nbsp;&nbsp;&nbsp;&nbsp;<input  class="text" name="upgrade_port_price" value="' + port_price + '"/>元，最多<input class="text" name="upgrade_port_max" value="' + port_max + '"/>Mb<br />' +
              '<strong>ＩＰ</strong>：每增加一个<strong>ＩＰ</strong>价格为<input  class="text" name="upgrade_ip" value="' + ip + '"/>元，最多<input  class="text" name="upgrade_ip_max" value="' + ip_max + '"/>个<label style="margin-left:28px"><input type="checkbox" name="upgrade_ip_discount" value="1" ' + (productData[0].pupgrade.ip_discount == '1' ? 'checked="checked"' : '') + ' />增加IP可享受折扣</label><br />' +
              '<strong>备份</strong>：每增加一个<strong>快照</strong>价格为<input  class="text" name="upgrade_snapshot_price" value="' + snapshot_price + '"/>元，最多<input  class="text" name="upgrade_snapshot_max" value="' + snapshot_max + '"/>个<span style="margin-left:33px">每增加一个<strong>完整备份</strong>价格</span><input  class="text" name="upgrade_full_backup_price" value="' + full_backup_price + '"/>元，最多<input  class="text" name="upgrade_full_backup_max" value="' + full_backup_max + '"/>个' +
              '<br /><input type="button" class="button dup" value="快速调整参数到不允许升级"/>' +
              '</div></div>';

    productConfig.html('<div id="xspc">' + str + '</div>');
    productConfig.find("#xspc").accordion({
        header: "> div > h3",
        heightStyle: "content",
        collapsible: true
    });
    productConfig.find("#xsBaseConfig .text,#xsUpgradeConfig .text").addClass("center").css({ "width": "50px" });

    productConfig.find(".dup").click(function () {
        productConfig.find("input[name='upgrade_cpu_max']").val(productConfig.find("input[name='config_cpu']").val());
        productConfig.find("input[name='upgrade_ram_max']").val(productConfig.find("input[name='config_ram_max']").val());
        productConfig.find("input[name='upgrade_disk_max']").val(productConfig.find("input[name='config_disk']").val());
        productConfig.find("input[name='upgrade_ip_max']").val(productConfig.find("input[name='config_ipc']").val());
        productConfig.find("input[name='upgrade_snapshot_max']").val(productConfig.find("input[name='config_snapshot']").val());
        productConfig.find("input[name='upgrade_full_backup_max']").val(productConfig.find("input[name='config_full_backup']").val());
        if (productConfig.find("input[name='config_bw']").val() != '0') productConfig.find("input[name='upgrade_bw_max']").val(productConfig.find("input[name='config_bw']").val());
        if (productConfig.find("input[name='config_port']").val() != '0') productConfig.find("input[name='upgrade_port_max']").val(productConfig.find("input[name='config_port']").val());
    });


    var psg = productData[0].pconfig.servergroup == undefined ? '0'.split(',') : productData[0].pconfig.servergroup.split(',');
    var aos = productData[0].pconfig.allowos == undefined ? '0'.split(',') : productData[0].pconfig.allowos.split(',');

    str = '';
    $(dclist).each(function (i) {
        str += '<option value="' + dclist[i].did + '">' + dclist[i].dname + '</option>';
    });
    productConfig.find("select[name='config_servergroup']").append(str).val(psg);
    str = '';
    $(oslist).each(function (i) {
        str += '<option value="' + oslist[i].oid + '">' + oslist[i].oid + '.' + oslist[i].oname + '</option>';
    });
    productConfig.find("select[name='config_allowos']").append(str).val(aos);
    productConfig.find("a").css("color","#0000FF")
}


_pm_init();
