﻿/// <reference path="/files/js/jquery.min.js" />
/// <reference path="/files/js/jquery.ui.min.js" />

var serviceConfig_form = $("#ServiceConfig");
var currentHost = '$currentHost';
var vpsid = serviceData[0].ssid;
var vps = serviceData[0].sconfig;
function _pm_init() {
    var backup_snapshot = vps.backup_snapshot == undefined ? '0' : vps.backup_snapshot;
    var backup_full = vps.backup_full == undefined ? '0' : vps.backup_full;
    var portmap = vps.portmap == undefined ? '0' : vps.portmap;
    var domain = vps.domain == undefined ? '0' : vps.domain;

    var ram_max = vps.vram == undefined ? '0' : vps.vram;
    var ram_min = vps.ram_min == undefined ? ram_max : vps.ram_min;
    ram_max = vps.ram_max == undefined ? ram_max : vps.ram_max;

    var str = '<strong>云主机编号：</strong><a href="javascript:;" id="viewInfo">#' + vpsid + '</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span>操作系统：</span><span id="vos">' + vps.vos + '</span>&nbsp;&nbsp;&nbsp;<a href="' + protocol + '://' + currentHost + '/process.aspx?c=go&url=' + escape('?c=mvps&id=' + vpsid) + '" class="dialog_button" target="_blank">进入XenSystem面板管理</a><br />' +
                '<strong>服务器分组：</strong><select name="did"></select> 显示名称：<input class="text" style="width:210px" name="dcname" value="' + vps.dcname + '"/><br />' +
                '<strong>所在服务器：</strong><select name="serverid"><option>Loading...</option></select> 显示名称：<input class="text" style="width:208px" name="servername" value="' + vps.servername + '"/><br />' +
                '<strong>云主机配置：</strong><input name="update" type="checkbox" value="1" />立即更新主机配置(可能需要重启)<br />' +
                '<strong>CPU数量：</strong><input name="vcpu" style="width:50px" class="text" value="' + vps.vcpu + '"/> CPUs&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span>内存</span>：<input style="width:50px" name="ram_min" class="text center" value="' + ram_min + '"/> ~ <input style="width:50px" name="ram_max" class="text center" value="' + ram_max + '"/> MB&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span>硬盘</span>：<input style="width:50px" name="vdisk" class="text" value="' + vps.vdisk + '"/> GB<br />' +
                '<strong>每月可用流量：</strong><input name="vbandwidth" style="width:50px" class="text" value="' + vps.vbandwidth + '"/> GB(0为不限)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span>端口</span>：<input style="width:50px" name="vport" class="text" value="' + vps.vport + '"/> Mbps(0为不限)<br />' +
                '<strong>可用备份集数：</strong><input name="backup_snapshot" style="width:50px" class="text" value="' + backup_snapshot + '"/>个快照，<input style="width:50px" name="backup_full" class="text" value="' + backup_full + '"/>个完整备份&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' +
                '<input type="checkbox" name="shareip" value="1" id="shareip" ' + (vps.shareip == '1' ? 'checked="checked"' : '') + '/><label for="shareip" style="font-weight:bold">共享IP型主机：</label>可映射<input name="portmap" style="width:50px" class="text" value="' + portmap + '"/>个端口，可绑定<input style="width:50px" name="domain" class="text" value="' + domain + '"/>个域名<br />' +
                '<hr />' +
                '<div id="moreInfo">Loading...</div>';

    serviceConfig_form.html(str);
    serviceConfig_form.find(".dialog_button").button();
    serviceConfig_form.css({ "line-height": "30px"});
    _pm_loadData();
}

function _pm_loadData() {
    var vstatus = "超流量停机|超流量运行|欠费停机|安装中|锁定|正常".split('|');
    var vsselect = '';
    for (i = 2; i > -4; i--) {
        vsselect += '<option value="' + i + '">' + vstatus[i + 3] + '</option>';
    }

    allowSaving = 0;
    $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vpsinfo&' + new Date(), function (rdata) {
        if (rdata == null) {
            alert('服务器数据读取错误！');
            return false;
        }
        var str = '<strong>主机别名：</strong><input name="vname" style="width:135px" value="' + vps.vname + '" class="text"/>&nbsp;&nbsp;&nbsp;<span>主机状态：</span><select name="vstatus">' + vsselect + '</select><br />' +
                '<strong>主IP地址：</strong><select name="vip"><option>Loading...</option></select>&nbsp;&nbsp;&nbsp;<span>MAC地址：</span>' + rdata[0].vmac + '<br />' +
                '<strong>额外IP地址：</strong><select name="additionalIP" multiple="multiple" style="height:80px"></select>&nbsp;&nbsp;&nbsp;按(Ctrl)多选<br />' +
                '<strong>实时资源状况：</strong>CPU使用:' + rdata[0].ucpu + '%&nbsp;&nbsp;&nbsp;磁盘i/o:' + rdata[0].uio + '&nbsp;&nbsp;&nbsp;已用流量:<input class="text" style="width:80px" name="bwusage" value="' + ((parseInt(rdata[0].cbandwidth) + parseInt(rdata[0].tbandwidth) - parseInt(rdata[0].lbandwidth)) / 1024 / 1024 / 1024).toFixed(3) + '"/>G' +
                '&nbsp;&nbsp;&nbsp;重置日期:<input class="text" style="width:80px" name="bwdate" value="' + rdata[0].bwdate.replace(' 0:00:00', '') + '"/><br />' +
                '<strong>主机操作限制：</strong>限制日期标记:<input name="config_cvdate" class="text" style="width:88px" value="' + (rdata[0].vconfig.cvdate == undefined ? '0' : rdata[0].vconfig.cvdate) + '"/>&nbsp;&nbsp;&nbsp;已经重装次数:<input name="config_rvcount" class="text" style="width:38px" value="' + (rdata[0].vconfig.rvcount == undefined ? '0' : rdata[0].vconfig.rvcount) + '"/><br />' +
                '<input type="hidden" name="vos" value="' + rdata[0].vos + '"/><input type="hidden" name="imageid" value="' + rdata[0].imageid + '"/><input type="hidden" name="ipcount" value="' + vps.ipcount + '"/>';

        serviceConfig_form.find("#moreInfo").html(str);
        serviceConfig_form.find("#vos").text(rdata[0].vos);
        serviceConfig_form.find("select[name='vstatus']").val(rdata[0].vstatus);
        serviceConfig_form.find("strong").css({
            "width": "100px",
            "text-align": "right",
            "float": "left",
            "font-weight": "bold",
            "cursor": "text"
        });
        serviceConfig_form.find("span").css({
            "font-weight": "bold"
        });
        serviceConfig_form.find("input[name='bwdate']").datepicker({
            dateFormat: "yy/mm/dd",
            changeMonth: true,
            changeYear: true
        });

        $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=getservergroup&' + new Date(), function (dcdata) {
            str = '';
            $(dcdata).each(function (i) {
                str += '<option value="' + dcdata[i].did + '">' + dcdata[i].did + '.' + dcdata[i].dname + '</option>';
            });
            suwin.find("select[name='did']").append(str).val(rdata[0].did).change(function () {
                _pm_loadServerList();
            });
            _pm_loadServerList(rdata);
        });
    });
}



function _pm_loadServerList(vdata) {
    allowSaving = 0;
    var did = suwin.find("select[name='did']").val();
    var sSelect = suwin.find("select[name='serverid']");
    sSelect.find("option").remove();
    $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=getserverlist&servergroup=' + did + '&' + new Date(), function (sdata) {
        str = '';
        $(sdata).each(function (i) {
            str += '<option value="' + sdata[i].sid + '">' + sdata[i].sid + '.' + sdata[i].sname + ' [' + sdata[i].maxcpu + 'CPUs/' + sdata[i].allowram + 'M/' + sdata[i].allowdisk + 'G]</option>';
        });
        sSelect.append(str);
        if (vdata != undefined) sSelect.val(vdata[0].sid);
        sSelect.change(function () { _pm_loadIPList(); });
        _pm_loadIPList(vdata);
    });
}

function _pm_loadIPList(vdata) {
    var ipsid = suwin.find("select[name='serverid']").val();
    var ipstr = '';
    var ipvid = vdata == undefined ? '0' : vpsid;
    suwin.find("select[name='vip'] option").remove();
    suwin.find("select[name='additionalIP'] option").remove();
    $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=iplist&ajax_id=-1&ajax_p1=' + ipsid + '&ajax_p2=' + ipvid + '&' + new Date(), function (idata) {
        $(idata).each(function (i) {
            ipstr += '<option value="' + idata[i].ip + '">' + idata[i].ip + '</option>';
        });
        serviceConfig_form.find("select[name='vip']").append(ipstr);
        if (vdata != undefined) serviceConfig_form.find("select[name='vip']").val(vdata[0].vip);
        serviceConfig_form.find("select[name='additionalIP']").append(ipstr);
        if (vps.additionalIP != undefined) serviceConfig_form.find("select[name='additionalIP']").val(vps.additionalIP.split(','));
        allowSaving = 1;
        serviceConfig_form.find("select[name='additionalIP']").change(function () {
            var additionalIPs = $(this).val();
            var ipcount = additionalIPs == null ? 1 : additionalIPs.length + 1;
            if (ipcount > 1) {
                if ((',' + additionalIPs.toString() + ',').indexOf(',' + serviceConfig_form.find("select[name='vip']").val() + ',') > -1) {
                    ipcount--;
                }
            }
            serviceConfig_form.find("input[name='ipcount']").val(ipcount);
        });
    });
}

_pm_init();


