﻿/// <reference path="/files/js/jquery.min.js" />
/// <reference path="/files/js/jquery.ui.min.js" />
/// <reference path="/files/js/script.js" />

var xs_cAction = rGet(curl, 'c');
var moduleID = $moduleID;
if (xs_cAction == 'mnotice') {
    $('<tr id="xs_users"><td class="title">XenSystem用户集：</td><td><a href="javascript:xs_selectUids(0);" style="font-weight:bold;">选择服务器所在用户</a><span class="xs_uids">已选择：<strong>0</strong></span></td></tr>').insertAfter("#users").find("a").button();

    function xs_selectUids(action) {
        if (action == 0) {
            swin.html(ajaxLoading());
            $.getJSON('?c=module&moduleid=' + moduleID + '&action=custom_action&show=text&subaction=getservergroup&' + new Date(), function (sgdata) {
                swin.html('<form><div id="idslist"><input type="checkbox" id="xs_selectAll"><label for="xs_selectAll"><strong>选择所有服务器节点下的用户</strong></label></div></form>');
                var serverID = '0';
                var sgID = '0';
                var idslist = swin.find("#idslist");

                $(sgdata).each(function (g) {
                    sgID = sgdata[g].did;
                    idslist.append('<div style="font-weight:bold;clear:both;padding:10px 0px 0px 18px"><input type="checkbox" id="pg' + sgID + '" onclick="selectSGCheckbox(this);"/><label for="pg' + sgID + '">' + sgdata[g].dname + '</label></div><div id="slist' + sgID + '"></div>');
                    $.getJSON('?c=module&moduleid=' + moduleID + '&action=custom_action&show=text&subaction=getserverlist&servergroup=' + sgID + '&' + new Date(), function (sdata) {
                        $(sdata).each(function (i) {
                            serverID = sdata[i].sid;
                            idslist.find('#slist' + sdata[i].did).append('<div style="clear:both;padding:5px 0px 0px 35px"><input type="checkbox" name="serverids" value="' + serverID + '" id="ids' + serverID + '"><label for="ids' + serverID + '">[' + serverID + '] <strong>' + sdata[i].sname + '</strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;IP地址：<strong>' + sdata[i].sip + '</strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;主机数：<strong>' + sdata[i].vcount + '</strong></label></div>');
                        });
                    });
                });
                swin.find("#xs_selectAll").click(function () {
                    $(this).parent().find("input:checkbox").prop("checked", $(this).prop("checked"));
                });
            });
            swin.dialog({ title: "选择服务器节点所在用户", autoOpen: false, resizable: false, width: 688, height: 538, modal: true, buttons: { "确定(Ctrl+Enter)": function () { xs_selectUids(1); }, "关 闭": function () { $(this).dialog("close"); } } }).dialog("open");

        }
        else {
            processing('正在获取用户ID，请稍候...');
            var delay = 0;
            var cmd = '';
            $.post('?c=module&moduleid=' + moduleID + '&action=custom_action&show=text&subaction=getserverusers', swin.find("form:first").serialize(), function (rdata) {
                var rmsg = rdata.split('|');
                switch (rmsg[0]) {
                    case "0":
                        rdata = "获取用户ID成功！！";
                        cmd = 'close';
                        delay = 1;
                        $("#sform input[name='uids']").val(rmsg[1]);
                        swin.dialog("close");
                        var ucount = rmsg[1].split(',').length;
                        if (rmsg[1] == '') ucount = 0;
                        $("#xs_users .xs_uids strong").text(ucount);
                        break;
                    case "-1": rdata = rmsg[1]; break;
                }
                showResults(rdata, delay, cmd);
            });
        }
    }

    function selectSGCheckbox(cthis) {
        var csgid = $(cthis).attr("id").substring(2);
        swin.find("#slist" + csgid + " input:checkbox").prop("checked", $(cthis).prop("checked"));
    }

}
else if (xs_cAction == 'mservice') {
    function xs_search(saction) {
        if (saction == 0) {
            swin.html('<p style="line-height:38px">' +
                  '<strong>主机编号：</strong><input name="id" class="text" /><br />' +
                  '<strong>uuid编号：</strong><input name="uuid" class="text" /><br />' +
                  '<strong>ＩＰ地址：</strong><input name="ip" class="text"/><br />' +
                  '<strong>MAC地址：</strong><input name="mac" class="text"/><br />' +
                  '</p>');
            swin.find(".text").css("width", "208px");
            swin.dialog({ title: 'XenSystem 云主机搜索', autoOpen: false, resizable: false, width: 388, height: 300, modal: true, buttons: { '搜索(Ctrl+Enter)': function () { xs_search(1); }, '关 闭': function () { $(this).dialog("close"); } } }).dialog("open");
        }
        else {
            processing('正在搜索，请稍候...');
            $.get('?c=module&moduleid=' + moduleID + '&action=custom_action&show=text&subaction=searchvps&vpsid=' + swin.find("input[name='id']").val() + '&uuid=' + swin.find("input[name='uuid']").val() + '&ip=' + swin.find("input[name='ip']").val() + '&mac=' + swin.find("input[name='mac']").val() + '&' + new Date(), function (rdata) {
                var rmsg = rdata.split('|');
                if (rmsg[0] == '0') showResults('未找到相关的云主机记录！', 0, '');
                else if (rmsg[0] == '-1') showResults(rmsg[1], 0, '');
                else top.location = '?c=mservice&ssid=' + rdata;
            });
        }
    }
    mainContent.find(".buttonList").append('<a href="javascript:xs_search(0);">云主机搜索</a>');
}