﻿/// <reference path="/files/js/jquery.min.js" />
/// <reference path="/files/js/jquery.ui.min.js" />

var orderConfig;
var currentHost = '$currentHost';
var vcpu, vram, vdisk, vbw, vport;
var pconfig_ram_max = '0';
var isAdmin = ia;
var bkID = rGet(curl, "bkid");
var bkData = $.parseJSON('[{"isEmpty":"true"}]');
function _pm_init() {
    orderConfig = $("#OrderConfig");
    var str = '<div id="xs_order_step">' +
              '<h3><a href="#"><strong class="pname">Loading...</strong></a></h3><div>' +
              '<span class="pdes">正在读取产品数据，请稍候...</span></div>';
    var ipMin = productData[0].pconfig.ipc == undefined ? 1 : parseInt(productData[0].pconfig.ipc);
    var ipMax = productData[0].pupgrade.ip_max == undefined ? 1 : parseInt(productData[0].pupgrade.ip_max);
    if (ipMax < ipMin) ipMax = ipMin;
    var snapshotMin = productData[0].pconfig.snapshot == undefined ? 0 : parseInt(productData[0].pconfig.snapshot);
    var snapshotMax = productData[0].pupgrade.snapshot_max == undefined ? 0 : parseInt(productData[0].pupgrade.snapshot_max);
    if (snapshotMax < snapshotMin) snapshotMax = snapshotMin;
    var fullBackupMin = productData[0].pconfig.full_backup == undefined ? 0 : parseInt(productData[0].pconfig.full_backup);
    var fullBackupMax = productData[0].pupgrade.full_backup_max == undefined ? 0 : parseInt(productData[0].pupgrade.full_backup_max);
    if (fullBackupMax < fullBackupMin) fullBackupMax = fullBackupMin;

    pconfig_ram_max = productData[0].pconfig.ram == undefined ? '0' : productData[0].pconfig.ram;
    pconfig_ram_max = productData[0].pconfig.ram_max == undefined ? pconfig_ram_max : productData[0].pconfig.ram_max;
    
    if (isAdmin) {
        str += '<h3><a href="#"><strong>指定节点服务器和IP地址（管理员功能）</strong></a></h3><div>' +
              '<select id="select_sid" multiple="multiple" style="height:108px;"><optgroup label="指定云主机所在的节点服务器"><option>Loading...</option></optgroup></select>' +
              '<select name="ips" multiple="multiple" style="height:108px;margin-left:28px;"><optgroup label="指定云主机的IP地址"></optgroup></select><br />&nbsp;<br />' +
              '<strong>提示：</strong>本产品标配<strong>' + ipMin + '</strong>个地址，如果您不选定以上参数，则默认由系统自动调配 ' + (isAdmin ? '&nbsp;&nbsp;&nbsp;<a href="?c=mproducts&pgtype=' + ptype + '&pid=' + productData[0].pid + '" target="_blank">『编辑此产品参数』</a>' : '') + '<br />' +
              '</div>';
    }
    str += '<h3><a href="#"><strong>第一步：配置云主机硬件性能和资源</strong></a></h3><div style="line-height:38px">' +
            '<p>&nbsp;CPU数量(核)：<input class="configText" type="text" name="vcpu"/><span class="ptext"></span></p><div id="sl_cpu"></div>' +
            '<p>内存大小(MB)：<input class="configText" type="text" name="vram"/><span class="ptext"></span></p><div id="sl_ram"></div>' +
            '<p>硬盘容量(GB)：<input class="configText" type="text" name="vdisk"/><span class="ptext"></span></p><div id="sl_disk"></div>' +
            '<p>带宽流量(GB)：<input class="configText" type="text" name="vbw"/><span class="ptext"></span></p><div id="sl_bw"></div>' +
            '<p>网络端口(Mb)：<input class="configText" type="text" name="vport"/><span class="ptext"></span></p><div id="sl_port"></div></div>';

    str += '<h3><a href="#"><strong>第二步：选择云主机操作系统、别名、IP地址数量及备份集数量</strong></a></h3><div style="line-height:38px">' +
              '操作系统：<button class="btn_vos dialog_button">选择操作系统</button><br />' +
              '主机别名：<input class="text" style="width:218px;" name="vname" value="MyServer"/><br />' +
              '&nbsp;&nbsp;&nbsp;IP地址数量：<select class="price_select" name="ipcount">';
    for (i = ipMin; i <= ipMax; i++) str += '<option value="' + i.toString() + '">' + i.toString() + '个</option>';
    str += '</select> <span class="ip_price"></span><br />';
    str += '&nbsp;&nbsp;&nbsp;备份集数量：快照:<select class="price_select" name="snapshot">';
    for (i = snapshotMin; i <= snapshotMax; i++) str += '<option value="' + i.toString() + '">' + i.toString() + '个</option>';
    str += '</select> <span class="snapshot_price"></span>&nbsp;&nbsp;&nbsp;完整备份:<select class="price_select" name="full_backup">';
    for (i = fullBackupMin; i <= fullBackupMax; i++) str += '<option value="' + i.toString() + '">' + i.toString() + '个</option>';
    str += '</select> <span class="full_backup_price"></span></div>';
   
    str +=  '<h3><a href="#"><strong>第三步：选择付款周期模式</strong></a></h3><div>' +
            '<p id="pcycle"></p></div>' +
            '</div><input type="hidden" name="serverid"/><input type="hidden" name="vos"/><input type="hidden" name="imageid"/>';
    orderConfig.html(str);
    vcpu = orderConfig.find("input[name='vcpu']");
    vram = orderConfig.find("input[name='vram']");
    vdisk = orderConfig.find("input[name='vdisk']");
    vbw = orderConfig.find("input[name='vbw']");
    vport = orderConfig.find("input[name='vport']");
    orderConfig.find(".configText").attr("readonly", "readonly").css("border", "0px").css("width", "80px").css("font-weight", "bold");
    orderConfig.find(".btn_vos").css({ "color": "#000000", "font-weight": "bold" }).button().click(function () {
        _pm_selectVOS();
        return false;
    });
    
    if (isAdmin) {
        str = '';
        $.getJSON('?c=module&productid=' + productID + '&action=custom_action&show=text&subaction=getserverlist&rt=json&' + new Date(), function (sdata) {
            orderConfig.find("#select_sid option").remove();
            if (sdata[0].isEmpty != 'true') {
                $(sdata).each(function (i) {
                    if (parseFloat(productData[0].pconfig.cpu) > parseFloat(sdata[i].maxcpu) || parseFloat(pconfig_ram_max) > parseFloat(sdata[i].allowram) || parseFloat(productData[0].pconfig.disk) > parseFloat(sdata[i].allowdisk)) return true;
                    str += '<option value="' + sdata[i].sid + '">' + sdata[i].sid + '. ' + sdata[i].sname + ' [' + sdata[i].maxcpu + 'CPUs/' + sdata[i].allowram + 'M/' + sdata[i].allowdisk + 'G]</option>';
                });
            }
            orderConfig.find("#select_sid").append(str);
            orderConfig.find("#select_sid").change(function () {
                var selectSid = $(this).val() == null ? "0" : $(this).val().toString().split(',')[0];
                _pm_setData(selectSid);
            });
        });

    }

    var serviceID = rGet(curl, "serviceid");

    if (bkID != '' && serviceID != '') {
        $.getJSON('?c=module&serviceid=' + serviceID + '&action=custom_action&show=text&subaction=vps_fields&ajax_id=' + bkID + '&ajax_p2=1&rt=json&' + new Date(), function (_bkdata) {
            bkData = _bkdata;
            if (bkData[0].isEmpty != 'true') {
                _pm_setData(bkData[0].fconfig.serverid);
            } else _pm_setData('0');
        });
    }
    else _pm_setData('0');

    orderConfig.find("#xs_order_step h3 strong");
    orderConfig.find("#xs_order_step").accordion({
        heightStyle: "content",
        collapsible: true,
        active: 0
    });
}

function _pm_outStock() {
    swin.html('<div class="ui-state-highlight ui-corner-all" style="padding: 10px;margin-top:168px"><strong>此套餐已经销售完毕，请选择其它产品套餐，如需帮助请与客服联系！</strong></div>');
    swin.dialog({ title: "产品已销售完毕", autoOpen: false, resizable: false, width: 800, height: 518, modal: true, buttons: { "关 闭": function () { $(this).dialog("close"); } } }).dialog("open");
}

function _pm_setData(serverID) {
    var pdata = productData[0];
    timeCycle = pdata.psconfig.time_cycle == undefined ? '0' : pdata.psconfig.time_cycle;
    var discount = parseFloat(pdata.discount);
    var pcycles = pdata.pprice.cycle.split(',');
    var pcprice = pdata.pprice.cprice.split(',');
    var paystr = '';
    var pp1 = 0, pp2 = 0;
    switch (pdata.pprice.pmothod) {
        case "1":
            paystr = '付款周期：';
            for (i = 0; i < pcycles.length; i++) {
                if (pcprice[i] != '0') {
                    if (pp1 == 0) pp1 = parseFloat(pcprice[i]) / parseInt(pcycles[i]);
                    else {
                        pp2 = (parseFloat(pcprice[i]) / parseInt(pcycles[i]) / pp1 * 10).toFixed(1);
                    }
                    paystr += '<label><input type="radio" name="baseprice" value="' + pcycles[i] + '_' + pcprice[i] + '_1" />/' + getTimeCycleSuffix(pcycles[i], timeCycle, 0) + (pp2 != 0 ? '(' + pp2 + '折)' : '') + '</label>　';
                }
            }
            break;
        case "2":
            paystr = '一次性付款：<input type="radio" name="baseprice" value="1_' + pdata.pprice.onetime + '_2"/>起始价:' + pdata.pprice.onetime + '元';
            break;
    }
    orderConfig.find("#pcycle").html(paystr);
    orderConfig.find("#pcycle input:first").prop("checked", "checked");
    var pconfig_ipc = pdata.pconfig.ipc == undefined ? '1' : pdata.pconfig.ipc;

    $.getJSON('?c=module&productid=' + productID + '&action=custom_action&show=text&subaction=getserverconfig&rt=json&ajax_p2=' + pconfig_ipc + '_' + pdata.pconfig.cpu + '_' + pconfig_ram_max + '_' + pdata.pconfig.disk + '&serverid=' + serverID + '&' + new Date(), function (sdata) {
        if (sdata[0].isEmpty == 'true') {
            _pm_outStock();
            return false;
        }
        if (isAdmin) {
            orderConfig.find("select[name='ips'] option").remove();
            orderConfig.find("select[name='ips'] optgroup").attr("label", "Loading...");
            $.getJSON('?c=module&productid=' + productID + '&action=custom_action&show=text&subaction=getiplist&serverid=' + sdata[0].sid + '&' + new Date(), function (sdata) {
                var str = '';
                $(sdata).each(function (i) { str += '<option value="' + sdata[i].ip + '">' + sdata[i].ip + '</option>'; });
                orderConfig.find("select[name='ips']").append(str);
                orderConfig.find("select[name='ips'] optgroup").attr("label", "指定云主机的IP地址(Ctrl可多选)");
                orderConfig.find("select[name='ips']").change(function () {
                    var ipcs = $(this).val() == null ? 0 : $(this).val().toString().split(',').length;
                    orderConfig.find("select[name='ipcount']").val(ipcs).change();
                });
            });
        }

        $("#priceDisplays").remove();
        $('<div id="priceDisplays" style="float:left;padding:5px 0px 0px 15px;"><strong>总价格：</strong><strong id="normalPrice" class="pricing"></strong><span id="finalPrice"></span></div>').insertBefore(".ui-dialog-buttonset");

        var mindisk = parseFloat(pdata.pconfig.disk);
        if (bkID != '') {
            orderConfig.find(".pname").html('使用备份镜像创建：');
            if (bkData[0].fconfig == undefined || bkData[0].fconfig.osid == undefined) {
                orderConfig.find(".pdes").html('您当前使用的备份镜像无法创建系统，只能通过选择系统全新安装！');
            }
            else {
                orderConfig.find(".pdes").html('<strong>备份镜像：</strong>' + bkData[0].fconfig.backup_name + '　　　<strong>操作系统：</strong>' + bkData[0].fconfig.os + '');
                orderConfig.find(".btn_vos").button("option", "label", bkData[0].fconfig.os).button("disable");
                orderConfig.find("input[name='vos']").val(bkData[0].fconfig.osid);
                orderConfig.find("input[name='imageid']").val(bkData[0].fid);
                if (mindisk < parseFloat(bkData[0].fconfig.vdisk)) mindisk = parseFloat(bkData[0].fconfig.vdisk);
            }
        }
        else {
            orderConfig.find(".pname").html(pdata.pname + ' 套餐描述：');
            orderConfig.find(".pdes").html(htmlDecode(pdata.pdes).replaceAll('<br />', ' / '));
        }
        if (serverID == '0') serverID = sdata[0].sid;
        orderConfig.find("input[name='serverid']").val(serverID);
        var mincpu = parseFloat(pdata.pconfig.cpu);
        var maxcpu = parseFloat(pdata.pupgrade.cpu_max);
        if (maxcpu > parseInt(sdata[0].maxcpu)) maxcpu = parseInt(sdata[0].maxcpu);
        var cpu_step = parseFloat(pdata.pupgrade.cpu_step);
        var cpu_price = parseFloat(pdata.pupgrade.cpu_price);

        var minram = parseFloat(pconfig_ram_max);
        var maxram = parseFloat(pdata.pupgrade.ram_max);
        if (parseFloat(sdata[0].allowram) < maxram) maxram = parseFloat(sdata[0].allowram);
        var ram_step = parseFloat(pdata.pupgrade.ram_step);
        var ram_price = parseFloat(pdata.pupgrade.ram_price);


        var maxdisk = parseFloat(pdata.pupgrade.disk_max);
        if (parseFloat(sdata[0].allowdisk) < maxdisk) maxdisk = parseFloat(sdata[0].allowdisk);
        var disk_step = parseFloat(pdata.pupgrade.disk_step);
        var disk_price = parseFloat(pdata.pupgrade.disk_price);

        if (minram > maxram || mindisk > maxdisk) {
            _pm_outStock();
            return false;
        }

        var minbw = parseFloat(pdata.pconfig.bw);
        var maxbw = parseFloat(pdata.pupgrade.bw_max);
        var bw_step = parseFloat(pdata.pupgrade.bw_step);
        var bw_price = parseFloat(pdata.pupgrade.bw_price);

        var minport = parseFloat(pdata.pconfig.port);
        var maxport = parseFloat(pdata.pupgrade.port_max);
        var port_step = parseFloat(pdata.pupgrade.port_step);
        var port_price = parseFloat(pdata.pupgrade.port_price);

        var ip_price = pdata.pupgrade.ip == undefined ? 0 : parseFloat(pdata.pupgrade.ip);
        var snapshot_price = pdata.pupgrade.snapshot_price == undefined ? 0 : parseFloat(pdata.pupgrade.snapshot_price);
        var full_backup_price = pdata.pupgrade.full_backup_price == undefined ? 0 : parseFloat(pdata.pupgrade.full_backup_price);

        var cpup = cpu_price / cpu_step;
        var ramp = ram_price / ram_step;
        var diskp = disk_price / disk_step;
        var bwp = bw_price / bw_step;
        var portp = port_price / port_step;
        if (discount > 1) {
            cpup = cpup * discount;
            ramp = ramp * discount;
            diskp = diskp * discount;
            bwp = bwp * discount;
            portp = portp * discount;
            ip_price = ip_price * discount;
            snapshot_price = snapshot_price * discount;
            full_backup_price = full_backup_price * discount;
        }
        orderConfig.find(".ptext:eq(0)").html("　" + cpup.toFixed(2) + "元/核，最多" + maxcpu + "核");
        orderConfig.find(".ptext:eq(1)").html(ramp.toFixed(2) + "元/MB,最多" + maxram + "MB");
        orderConfig.find(".ptext:eq(2)").html(diskp.toFixed(2) + "元/GB,最多" + maxdisk + "GB");
        if (pdata.pconfig.bw == '0') {
            minbw = 0;
            maxbw = 0;
        }
        orderConfig.find(".ptext:eq(3)").html((maxbw == 0 ? '不限流量' : bwp.toFixed(2) + "元/GB,最多" + maxbw + "GB/月"));
        orderConfig.find(".ptext:eq(4)").html(portp.toFixed(2) + "元/Mb,最多" + maxport + "Mbps");
        orderConfig.find(".ip_price").html('单价：' + ip_price + '元/个');
        orderConfig.find(".snapshot_price").html('单价：' + snapshot_price + '元/个');
        orderConfig.find(".full_backup_price").html('单价：' + full_backup_price + '元/个');

        _pm_sliderIt(mincpu, maxcpu, cpu_step, cpu_price, minram, maxram, ram_step, ram_price, mindisk, maxdisk, disk_step, disk_price, minbw, maxbw, bw_step, bw_price, minport, maxport, port_step, port_price);
        orderConfig.find("#pcycle input").click(function () {
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        });
        orderConfig.find(".price_select").change(function () {
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        });
    });
}

function _pm_sliderIt(mincpu, maxcpu, cpu_step, cpu_price, minram, maxram, ram_step, ram_price, mindisk, maxdisk, disk_step, disk_price, minbw, maxbw, bw_step, bw_price, minport, maxport, port_step, port_price) {
    $("#sl_cpu").slider({
        range: "min",
        value: mincpu,
        min: 0,
        max: maxcpu,
        step: cpu_step,
        slide: function (event, ui) {
            vcpu.val(ui.value);
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        },
        stop: function (event, ui) {
            if (parseInt(ui.value) < mincpu) {
                $("#sl_cpu").slider("value", mincpu);
                vcpu.val(mincpu);
            }
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        }
    });
    vcpu.val(mincpu);
    $("#sl_cpu").slider("value", mincpu);

    $("#sl_ram").slider({
        range: "min",
        value: minram,
        min: 0,
        max: maxram,
        step: ram_step,
        slide: function (event, ui) {
            vram.val(ui.value);
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        },
        stop: function (event, ui) {
            if (parseInt(ui.value) < minram) {
                $("#sl_ram").slider("value", minram);
                vram.val(minram);
            }
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        }
    });
    vram.val(minram);
    $("#sl_ram").slider("value", minram);

    $("#sl_disk").slider({
        range: "min",
        value: mindisk,
        min: 0,
        max: maxdisk,
        step: disk_step,
        slide: function (event, ui) {
            vdisk.val(ui.value);
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        },
        stop: function (event, ui) {
            if (parseInt(ui.value) < mindisk) {
                $("#sl_disk").slider("value", mindisk);
                vdisk.val(mindisk);
            }
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        }
    });
    vdisk.val(mindisk);
    $("#sl_disk").slider("value", mindisk);

    var minVal = 0;
    if (maxbw == 0) {
        minVal = -1;
        vbw.css("color", "#FFFFFF");
    } else vbw.css("color", "#000000");
    $("#sl_bw").slider({
        range: "min",
        value: minbw,
        min: minVal,
        max: maxbw,
        step: bw_step,
        slide: function (event, ui) {
            vbw.val(ui.value);
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        },
        stop: function (event, ui) {
            if (parseInt(ui.value) < minbw) {
                $("#sl_bw").slider("value", minbw);
                vbw.val(minbw);
            }
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        }
    });
    vbw.val(minbw);
    $("#sl_bw").slider("value", minbw);

    if (minport == 0) minport = maxport;
    $("#sl_port").slider({
        range: "min",
        value: minport,
        min: 0,
        max: maxport,
        step: port_step,
        slide: function (event, ui) {
            vport.val(ui.value);
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        },
        stop: function (event, ui) {
            if (parseInt(ui.value) < minport) {
                $("#sl_port").slider("value", minport);
                vport.val(minport);
            }
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        }
    });
    vport.val(minport);
    $("#sl_port").slider("value", minport);
    _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
}

function _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step) {
    var pmothod = orderConfig.find("#pcycle input:radio:checked").val().split('_');
    var ipMin = productData[0].pconfig.ipc == undefined ? 1 : parseInt(productData[0].pconfig.ipc);
    var addIPC = parseInt(orderConfig.find("select[name='ipcount']").val());
    if (orderConfig.find("select[name='ips']").val() != null) {
        var selectedIPC = orderConfig.find("select[name='ips']").val().toString().split(',').length;
        if (selectedIPC != addIPC) addIPC = selectedIPC;
    }
    addIPC = addIPC - ipMin;
    var snapshotMin = productData[0].pconfig.snapshot == undefined ? 0 : parseInt(productData[0].pconfig.snapshot);
    var fullBackupMin = productData[0].pconfig.full_backup == undefined ? 0 : parseInt(productData[0].pconfig.full_backup);
    var addSnapshot = parseInt(orderConfig.find("select[name='snapshot']").val());
    var addFullBackup = parseInt(orderConfig.find("select[name='full_backup']").val());
    addSnapshot = addSnapshot - snapshotMin;
    addFullBackup = addFullBackup - fullBackupMin;

    billingCycle = parseInt(pmothod[0]);
    var basePrice = parseFloat(pmothod[1]);
    if (billingCycle == 0) basePrice = 0;
    normalPrice = (parseFloat(vcpu.val()) - mincpu) * cpu_price / cpu_step;
    normalPrice += (parseFloat(vram.val()) - minram) * ram_price / ram_step;
    normalPrice += (parseFloat(vdisk.val()) - parseFloat(productData[0].pconfig.disk)) * disk_price / disk_step;
    if (minbw > 0) normalPrice += (parseFloat(vbw.val()) - minbw) * bw_price / bw_step;
    if (minport > 0) normalPrice += (parseFloat(vport.val()) - minport) * port_price / port_step;
    if (addIPC > 0) normalPrice += addIPC * parseFloat(productData[0].pupgrade.ip);
    if (addSnapshot > 0) normalPrice += addSnapshot * parseFloat(productData[0].pupgrade.snapshot_price);
    if (addFullBackup > 0) normalPrice += addFullBackup * parseFloat(productData[0].pupgrade.full_backup_price);
    normalPrice = basePrice + normalPrice * billingCycle;
    if (normalPrice < basePrice) normalPrice = basePrice;

    var discount = parseFloat(productData[0].discount);
    finalPrice = normalPrice * discount;
    if (normalPrice > finalPrice) {
        $("#normalPrice").html('<strike>' + normalPrice.toFixed(2) + '</strike>');
        $("#finalPrice").html('<strong style="margin-left:18px">帐户优惠价(' + (discount * 100 / 10) + '折)：</strong><strong class="pricing">' + finalPrice.toFixed(2) + '</strong> ' + userData[0].currency);
    }
    else $("#normalPrice").html(finalPrice.toFixed(2) + ' ' + userData[0].currency);

    configDetails = '<strong>CPU数量</strong>：' + vcpu.val() + ' CPUs<br />' +
                    '<strong>内存大小</strong>：' + vram.val() + ' MB<br />' +
                    '<strong>硬盘容量</strong>：' + vdisk.val() + ' GB<br />' +
                    '<strong>IP地址数</strong>：' + (addIPC + ipMin) + ' 个<br />' +
                    '<strong>带宽流量</strong>：' + (vbw.val() == '0' ? '不限' : vbw.val()) + ' GB<br />' +
                    '<strong>网络端口</strong>：' + vport.val() + ' Mb<br />' +
                    '<strong>操作系统</strong>：' + orderConfig.find(".btn_vos span").text() + '<br />' +
                    '<strong>快照备份</strong>：' + (addSnapshot + snapshotMin) + ' 个<br />' +
                    '<strong>完整备份</strong>：' + (addFullBackup + fullBackupMin) + ' 个<br />';
}

function _pm_selectVOS() {
    suwin.html(ajaxLoading());
    $.getJSON('?c=module&productid=' + productID + '&action=custom_action&show=text&subaction=getoslist&rt=json&serverid=' + orderConfig.find("input[name='serverid']").val() + '&' + new Date(), function (rdata) {
        if (rdata[0].isEmpty == 'true') {
            suwin.html('');
            return false;
        }
        var allowOS = ',' + productData[0].pconfig.allowos + ',';
        var str = '<table style="width:100%">';
        var opath = protocol + '://' + currentHost + '/files/images/os/';
        var ico = '', des = '';
        var odes;
        $(rdata).each(function (i) {
            if (allowOS.indexOf(',0,') < 0 && allowOS.indexOf(',' + rdata[i].oid + ',') < 0) return true;
            if (typeof (rdata[i].odes) != 'object') {
                odes = rdata[i].odes.split('|');
                ico = odes[0];
                des = odes[1];
            } else {
                ico = rdata[i].odes.ico;
                des = rdata[i].odes.des;
            }
            str += '<tr class="ost" title="' + rdata[i].oid + '.' + rdata[i].oname + '"><td style="padding:10px 5px 10px 5px;width:39px;"><img src="' + opath + ico + '" alt=""/></td><td style="padding:10px 0px 0px 0px;line-height:21px;"><strong>' + rdata[i].oname + '</strong><br />' + htmlDecode(des) + '</td></tr>';
        });
        str += '</table>';
        suwin.html(str);
        suwin.find(".ost").css({ "cursor": "pointer" });
        suwin.find(".ost").mouseover(function () { $(this).find("td").css("background", "#EEEEEE"); }).mouseout(function () { $(this).find("td").css("background", "#FFFFFF"); });
        suwin.find(".ost").click(function () {
            des = $(this).attr("title");
            orderConfig.find("input[name='vos']").val(des.substring(0, des.indexOf('.')));
            orderConfig.find(".btn_vos span").text(des.substring(des.indexOf('.') + 1));
            suwin.dialog("close");
            orderConfig.find("#pcycle input:radio:checked").click();
        });
    });
    suwin.dialog({ title: "选择操作系统", autoOpen: false, resizable: false, width: 588, height: 518, modal: true, buttons: { "关 闭": function () { $(this).dialog("close"); } } }).dialog("open");
}

_pm_init();
