﻿/// <reference path="/files/js/jquery.min.js" />
/// <reference path="/files/js/jquery.ui.min.js" />
/// <reference path="/files/js/script.js" />


var ViewService = $("#ViewService");
var currentHost = '$currentHost';
var vcpu, vram, vdisk, vbw, vport;
var currentRam = '0';
var publicIP = '', privateIP = '', os_template = '';
var productDiscount = parseFloat(productData[0].discount);
var isAdmin = userData[0].isAdmin == 'True';
var vmID = serviceData[0].ssid;
var timeCycle = productData[0].psconfig.time_cycle == undefined ? '0' : productData[0].psconfig.time_cycle;

function _pm_init() {
    var ctitle = '管理我的云主机 #' + vmID;
    setTitle(ctitle);
    var userLink = '';
    currentRam = serviceData[0].sconfig.vram == undefined ? '0' : serviceData[0].sconfig.vram;
    currentRam = serviceData[0].sconfig.ram_max == undefined ? currentRam : serviceData[0].sconfig.ram_max;

    if (isAdmin) userLink = '<strong style="margin-left:38px">所属用户：</strong><a href="?c=muser&uid=' + userData[0].uid + '" target="_blank">' + userData[0].uname + ' [#' + userData[0].uid + ']</a>';
    else if (userData[0].isReseller == 'True') userLink = '<strong style="margin-left:38px">所属用户：</strong><a href="?c=rmuser&uid=' + userData[0].uid + '" target="_blank">' + userData[0].uname + ' [#' + userData[0].uid + ']</a>';
    var str = '<table width="100%" border="0" cellspacing="0" cellpadding="0" class="table grid">' +
              '<thead><tr><th style="text-align:right">云主机信息：</th><th>&nbsp;</th></tr></thead><tbody id="vcptb">' +
              addTR('编号＆别名：', '<strong>#' + vmID + '</strong>(' + serviceData[0].sconfig.vname + ')' + userLink) +
              addTR('服务器节点：', serviceData[0].sconfig.dcname + '<span>' + serviceData[0].sconfig.servername + '</span>') +
              addTR('操作系统：', '<strong id="vos">' + serviceData[0].sconfig.vos + '</strong><span><input type="button" name="reload" class="button" value="重装系统" /></span><span><input type="button" name="backup" class="button" value="备份/还原" /></span><span><input type="button" name="cd_manage" class="button" value="光驱管理" /></span><span id="vncconsole"><input type="button" name="console" class="button" value="VNC控制台" /></span>') +
              addTR('主机IP地址：', '<strong id="mainip">' + serviceData[0].sconfig.vip + '</strong><span><a href="javascript:mIPs()">『管理/添加IP地址』</a></span><span id="portmap"><a href="javascript:mPortmap();">『端口/域名管理』</a></span>') +
              addTR('云主机配置：', '<strong>CPU：</strong>' + serviceData[0].sconfig.vcpu + ' CPUs<span><strong>内存：</strong>' + currentRam + ' M</span><span><strong>硬盘：</strong>' + serviceData[0].sconfig.vdisk + ' G</span><span><strong>端口：</strong>' + (serviceData[0].sconfig.vport == "0" ? '不限' : '' + serviceData[0].sconfig.vport + ' M') + '</span><span><strong>流量：</strong>' + (serviceData[0].sconfig.vbandwidth == '0' ? '不限' : serviceData[0].sconfig.vbandwidth + ' G') + '</span><span><input type="button" name="upgrade" value="升级配置" class="button" /></span>') +
              addTR('流量情况：', '<div style="float:left" id="bwusage">Checking......</div>') +
              addTR('资源状态：', '<a href="javascript:showChart(1,5)">『CPU使用率』</a><span><a href="javascript:showChart(2,5)">『内存状态』</a></span><span><a href="javascript:showChart(3,5)">『磁盘I/O』</a></span><span><a href="javascript:showChart(4,5)">『网络流量』</a></span>');
    var duedate = getUnixTime(parseInt(serviceData[0].etime));
    duedate = duedate.substring(0, duedate.indexOf(' '));
    var tempstr = '';
    switch (serviceData[0].spmothod) {
        case "1":
            tempstr = '<strong id="vprice">' + serviceData[0].sprice + ' ' + userData[0].currency + '</strong> / ' + getTimeCycleSuffix(serviceData[0].spcycle, timeCycle, 1);
            break;
        case "2":
            tempstr = '<strong id="vprice">' + serviceData[0].sprice + '</strong> ' + userData[0].currency;
            break;
    }
    var sTrial = serviceData[0].strial == undefined ? 0 : parseFloat(serviceData[0].strial);
    if (sTrial > 0) tempstr += '（免费试用' + sTrial + '小时）';

    str += addTR('续费价格：', tempstr + '<span><strong>帐户余额：</strong>' + parseFloat(userData[0].balance).toFixed(2) + ' ' + userData[0].currency + '</span>');
    if (serviceData[0].spmothod == "1") {
        str += addTR('续费时间：', '<strong>' + duedate + '</strong><span style="color:#ABABAB">(请确保在日期前帐户余额充足)</span><span><input id="autorenew" type="checkbox" ' + (serviceData[0].autorenew == '0' ? 'checked="checked"' : '') + '/><label for="autorenew">自动续费</label><span><span><a href="javascript:_pm_renew(0);">『马上续费』</a></span>');
    }
    str += addTR('主机状态：', '<div id="vstatus"></div>') +
            addTR('管理操作：', '<input type="button" class="button" name="reboot" value="(软)重启" /><span><input type="button" name="shutdown" class="button" value="(软)关机" /></span><span><input type="button" name="start" class="button" value="开机" /></span><span><input type="button" name="hreboot" class="button" value="(硬)重启" /></span><span><input type="button" name="hshutdown" class="button" value="(硬)关机" /></span><span><input name="cvif" type="button" class="button" value="网卡控制" /></span>') +
            addTR('操作提示：', '如果(软)操作无效，请使用(硬)操作。注意：在(硬)重启或(硬)关机之前，请先保存好相关数据！') +
            addTR('默认密码：', '默认管理帐号：Windows: <strong>Administrator</strong>&nbsp;&nbsp;&nbsp;Linux: <strong>root</strong><span>初始密码：<strong id="defaultps"></strong><a href="javascript:viewPS();">『查看』</a> <a id="link_changeps" href="javascript:resetPS(0);">『重置』</a></span>');
     str +=  '</tbody></table>';
    
    ViewService.html(str);
    ViewService.find("span").css("margin-left", "10px")
    ViewService.find("#autorenew").click(function () {
        var autorenew = $(this).prop("checked") ? '0' : '1';
        setAutorenew(serviceData[0].sid, autorenew);
    });

    $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vpsexinfo&' + new Date(), function (exInfo) {
        os_template = exInfo.ostemplate;
        if (os_template == '') ViewService.find("#link_changeps").remove();
        if (exInfo.vnc_server == '0') ViewService.find("#vncconsole").remove();
        if (exInfo.publicIP != '') {
            publicIP = exInfo.publicIP;
            privateIP = exInfo.privateIP;
            ViewService.find("#mainip").html('公网IP：' + publicIP + '&nbsp;&nbsp;&nbsp;内网IP：' + privateIP);
        }
        if (exInfo.isSharedIP != '1') ViewService.find("#portmap").remove();
        if (exInfo.changePS == '1' && !resellerMode) ViewService.find(".table:first").append(addTR('独立面板：', '登录地址：<a href="' + exInfo.loginUrl + '" target="_blank">' + exInfo.loginUrl + '</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;用户名: <strong>' + userData[0].uname + '</strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" name="setPS" class="button" value="修改/设置密码" onclick="_pm_setPS(0);"/>'));
    });

    ViewService.find(".button").click(function () {
        var vaction = $(this).attr("name");
        var stext = "", wtext = "", otext = "";
        switch (vaction) {
            case "reload":
                reload();
                break;
            case "reboot":
            case "hreboot":
                stext = "您确定要重启主机[" + vmID + "]吗？";
                wtext = "正在重启主机，请稍候......";
                otext = "主机[" + vmID + "]重启成功！";
                break;
            case "shutdown":
            case "hshutdown":
                stext = "您确定要关闭主机[" + vmID + "]吗？";
                wtext = "正在关闭主机，请稍候......";
                otext = "主机[" + vmID + "]成功关闭！";
                break;
            case "start":
                stext = "您确定要启动主机[" + vmID + "]吗？";
                wtext = "正在启动主机，请稍候......";
                otext = "主机[" + vmID + "]启动成功！";
                break;
            case "upgrade": upgrade(0); break;
            case "console": vncConsole(''); break;
            case "cvif": cvif(); break;
            case "backup": backup(0); break;
            case "cd_manage": mCD(0); break;
        }
        if (stext != '') {
            swin.html('<p style="font-weight:bold;padding-top:20px;text-align:center;"><input type="checkbox" id="confirm_box" value="1"/><label for="confirm_box" style="cursor:pointer">' + stext + '<label></p>');
            swin.dialog({ title: "主机操作确认！", autoOpen: false, resizable: false, width: 399, height: 200, modal: true, buttons: { "确 定": function () { vmControl(vaction, wtext, otext, ''); }, "取 消": function () { $(this).dialog("close"); } } }).dialog("open");
        }
    });

    showVState();
    setInterval("showVState();", 300000);
    _pm_loadScript();
}

function mCD(action) {
    if (action == 0) {
        swin.html(ajaxLoading());
        $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vmcontrol&vaction=cd_manage&subvaction=state&' + new Date(), function (rdata) {
            var str = '<p style="line-height:28px;padding-top:38px;text-align:center"><strong>CD/DVD：</strong><select id="cdimage"><option value="">请选择ISO光驱镜像文件</option><option value="">弹出所有ISO光驱镜像</option>';
            $.each(rdata[0].images, function (key, value) {
                str += '<option value="' + value + '"' + (key == rdata[1].current ? ' selected="selected"' : '') + '>' + key + '</option>';
            });
            str += '</p>';
            swin.html(str);
            swin.find("#cdimage").change(function () { mCD(1); });
        });
        swin.dialog({ title: '光驱管理', autoOpen: false, resizable: false, width: 500, height: 230, modal: true, buttons: { '关 闭': function () { $(this).dialog("close"); } } }).dialog("open");
    }
    else {
        processing('正在处理，请稍候...');
        var delay = 0;
        var cmd = 'close';
        $.post('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vmcontrol&vaction=cd_manage&subvaction=change&' + new Date(), { "cd_image": swin.find("#cdimage").val() }, function (rdata) {
            var rmsg = rdata.split('|');
            if (rmsg[0] == "0") {
                rdata = '操作成功！';
                delay = 1500;
            } else if (rmsg[0] == "-1") {
                switch (rmsg[1]) {
                    default: rdata = rmsg[1];
                }
            }
            showResults(rdata, delay, cmd);
        });
    }
}

function vncConsole(action) {
    if (action == '') {
        swin.html(ajaxLoading('正在处理，请稍候...'));
        $.get('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vmcontrol&vaction=console&subvaction=state&rt=json&' + new Date(), function (rdata) {
            if (rdata.indexOf("-1|") > -1) swin.html(rdata.substring(3));
            else {
                var vncState = $.parseJSON(rdata);
                swin.html('<p style="padding-top:10px;text-align:center;line-height:35px"><strong>状态：</strong><span id="vcstate"></span><br /><button name="connect">立即连接</button>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<button name="enable">启用</button>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<button name="logout">注销</button></p>');
                if (vncState.state == 'enabled') {
                    swin.find("button[name='enable']").remove();
                    swin.find("#vcstate").html('已启用&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>会话过期时间：</strong>' + getUnixTime(vncState.expireTime));
                    setTimeout('vncConsole("keepalive");', 120000);
                } else {
                    swin.find("button[name='connect'],button[name='logout']").remove();
                    swin.find("#vcstate").text('已注销');
                }
                swin.find("button").addClass('dialog_button').button().click(function () {
                    var bAction = $(this).attr("name");
                    if (bAction == 'connect') window.open(protocol + '://' + currentHost + '/files/console/console.html?cc=' + encode(vncState.expireTime + '|' + vncState.vsip + '|' + vncState.port + '|' + vncState.token), '_blank');
                    else vncConsole(bAction);
                });
            }
        });
        swin.dialog({ title: 'VNC控制台', autoOpen: false, resizable: true, width: 398, height: 230, modal: true, buttons: { '关闭': function () { $(this).dialog("close"); } } }).dialog("open");
    }
    else if (action == 'keepalive') {
        if (swin.find("#vcstate").length > 0) vncConsole('');
    }
    else {
        processing('正在处理，请稍候...');
        var cmd = 'close';
        var delay = 0;
        $.get('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vmcontrol&vaction=console&subvaction=' + action + '&' + new Date(), function (rdata) {
            var rmsg = rdata.split('|');
            if (rmsg[0] == "0") {
                rdata = '操作成功！';
                delay = 1000;
                vncConsole('');
            }
            else rdata = rmsg[1];
            showResults(rdata, delay, cmd);
        });
    }
}

function mPortmap() {
    var str = '';
    var aPortmap = parseInt(serviceData[0].sconfig.portmap);
    swin.html(ajaxLoading());
    $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vps_fields&ajax_p2=2&rt=json&' + new Date(), function (rdata) {
        str = '<table width="100%" border="0" cellspacing="0" cellpadding="0" class="table">' +
              '<thead><tr><th>公网端口</th><th>&nbsp;</th><th>内网端口</th><th>&nbsp;</th></tr></thead>';
        if (rdata[0].isEmpty != 'true') {
            $(rdata).each(function (i) {
                str += '<tr id="tr' + rdata[i].fid + '"><td title="' + publicIP + ':' + rdata[i].forder + '">' + rdata[i].forder + '</td><td>&gt;&gt;&gt;</td><td>' + rdata[i].fvalue.privatePort + '</td><td><input type="button" name="del" class="button" value="删除端口映射"/></td></tr>';
                aPortmap--;
            });
        }
        str += '</table><div><p><strong>公网IP地址：</strong> ' + publicIP + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>内网IP地址：</strong> ' + privateIP + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>可映射的端口数：</strong>' + aPortmap + '</p>' +
               '<p><strong>内网IP端口：</strong><select id="portList"><option value="">常用端口</option><option value="3389">RDP</option><option value="22">SSH</option><option value="80">HTTP</option><option value="21">FTP</option><option value="1433">SQL Server</option><option value="3306">MySQL</option></select>' +
               '<input name="privatePort" style="width:168px" class="text" /> <input type="button" class="button" name="add" value="添加端口映射"/></div></p></div>';

        swin.html(str);
        swin.css("padding", "0px");
        swin.find("th,td").css({ "text-align": "center"});
        swin.find("#portList").change(function () { swin.find("input[name='privatePort']").val($(this).val()) });
        swin.find(".button").click(function () {
            var baction = $(this).attr("name");
            var exurl = '';
            exurl = 'subvaction=' + baction;
            if (baction == 'add') {
                exurl += '&privateport=' + swin.find("input[name='privatePort']").val();
                str = '<form><div style="line-height:30px;"><input type="checkbox" id="confirm_box" value="1"/><label for="confirm_box" style="cursor:pointer">您确定添加此端口映射规则吗？映射到内网端口：[' + swin.find("input[name='privatePort']").val() + ']</label></div></form>';
            }
            else if (baction == 'del') {
                var ctr = $(this).parent().parent();
                exurl += '&portid=' + ctr.attr("id").substring(2);
                str = '<form><div style="line-height:30px;"><input type="checkbox" id="confirm_box" value="1"/><label for="confirm_box" style="cursor:pointer">您确定要删除此端口映射规则吗？内网端口：[' + ctr.find('td:eq(2)').text() + ']</label></div></form>';
            }
            suwin.html(str);
            suwin.dialog({ title: '操作确认', autoOpen: false, resizable: false, width: 399, height: 168, modal: true, buttons: { '确定': function () { vmControl('portmap', '正在处理，请稍候...', '操作成功！', exurl); }, '取消': function () { $(this).dialog("close"); } } }).dialog("open");
        });
    });
    swin.dialog({ title: '管理端口映射', autoOpen: false, resizable: false, width: 599, height: 500, modal: true, buttons: { '管理域名绑定': function () { mDomain(); }, '关 闭': function () { $(this).dialog("close"); } } }).dialog("open");
}

function mDomain() {
    var str = '';
    var aDomain = parseInt(serviceData[0].sconfig.domain);
    swin.html(ajaxLoading());
    $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vps_fields&ajax_p2=3&rt=json&' + new Date(), function (rdata) {
        str = '<table width="100%" border="0" cellspacing="0" cellpadding="0" class="table">' +
              '<thead><tr><th>已绑定的域名</th><th>&nbsp;</th></tr></thead>';
        if (rdata[0].isEmpty != 'true') {
            $(rdata).each(function (i) {
                str += '<tr id="tr' + rdata[i].fid + '"><td>' + rdata[i].fname + '</td><td><input type="button" name="del" class="button" value="删除域名绑定"/></td></tr>';
                aDomain--;
            });
        }
        str += '</table><div><p><strong>请将域名A记录指向IP地址：</strong> ' + publicIP + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>可绑定域名数：</strong>' + aDomain + '</p>' +
                '<p><strong>域名：</strong><input name="domain" style="width:238px" class="text" /> <input type="button" class="button" name="add" value="添加域名绑定"/></p>' +
                '</div>';

        swin.html(str);
        swin.css("padding", "0px");
        swin.find("th,td").css({ "text-align": "center"});
        swin.find(".button").click(function () {
            var baction = $(this).attr("name");
            var exurl = '';
            exurl = 'subvaction=' + baction;
            if (baction == 'add') {
                exurl += '&domain=' + swin.find("input[name='domain']").val();
                str = '<form><div style="line-height:30px;"><input type="checkbox" id="confirm_box" value="1"/><label for="confirm_box" style="cursor:pointer">您确定添加绑定此域名吗？域名：[' + swin.find("input[name='domain']").val() + ']</label></div></form>';
            }
            else if (baction == 'del') {
                var ctr = $(this).parent().parent();
                exurl += '&domainid=' + ctr.attr("id").substring(2);
                str = '<form><div style="line-height:30px;"><input type="checkbox" id="confirm_box" value="1"/><label for="confirm_box" style="cursor:pointer">您确定要删除此域名绑定吗？域名：[' + ctr.find('td:eq(0)').text() + ']</label></div></form>';
            }
            suwin.html(str);
            suwin.dialog({ title: '操作确认', autoOpen: false, resizable: false, width: 399, height: 168, modal: true, buttons: { '确定': function () { vmControl('domain', '正在处理，请稍候...', '操作成功！', exurl); }, '取消': function () { $(this).dialog("close"); } } }).dialog("open");
        });
    });
    swin.dialog({ title: '管理域名绑定', autoOpen: false, resizable: false, width: 599, height: 500, modal: true, buttons: { '管理端口映射': function () { mPortmap(); }, '关 闭': function () { $(this).dialog("close"); } } }).dialog("open");
}


function _pm_setPS(action) {
    if (action == 0) {
        swin.html(ajaxLoading());
        $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=getsysconfig&' + new Date(), function (sysconfig) {
            var str = '<form action="?" style="line-height:35px;padding:10px;" onsubmit="return _pm_setPS(1);">' +
                      '<strong>当前用户名：</strong>' + userData[0].uname + '<br />' +
                      '<strong>发送验证码：</strong>' + (sysconfig.email_password_reset == '1' ? '<input type="button" onclick="sendVCode(2)" class="button" value="发到邮箱"/>' : '') + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + (sysconfig.sms_password_reset == '1' ? '<input type="button"  onclick="sendVCode(1)" class="button" value="发到短信"/>' : '') + '<br />' +
                      '<strong>输入验证码：</strong><input type="text" class="text" name="vcode"/><br />' +
                      '<strong>输入新密码：</strong><input type="password" class="text" name="ps1"/><br />' +
                      '<strong>重复新密码：</strong><input type="password" class="text" name="ps2"/><br />' +
                      '</form>';

            swin.html(str);
        });
        swin.dialog({ title: "重置密码", autoOpen: false, resizable: false, width: 399, height: 320, modal: true, buttons: { "重置密码": function () { _pm_setPS(1); }, "关 闭": function () { $(this).dialog("close"); } } }).dialog("open");
    }
    else {
        processing("正在重置密码，请稍候......");
        var delay = 0;
        var cmd = 'close';
        var cform = swin.find("form:first");
        $.post('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=resetpassword&' + new Date(), cform.serialize(), function (rdata) {
            var rmsg = rdata.split('|');
            if (rmsg[0] == "0") {
                rdata = '您的密码已经重置，请使用新密码登录！';
                delay = 3000;
                swin.dialog("close");
            } else if (rmsg[0] == "-1") {
                switch (rmsg[1]) {
                    case 'Invalid verification code': rdata = '您输入的验证码错误！'; break;
                    case "Invalid password length": rdata = "密码长度不能小于6位！"; break;
                    case "Password does not match": rdata = "两次输入的新密码不相同！"; break;
                    default: rdata = rmsg[1];
                }
            }
            showResults(rdata, delay, cmd);
        });
    }
}

function _pm_loadScript() {
    $.getScript(protocol + '://' + currentHost + '/files/js/excanvas.js', function () { });
    $.getScript(protocol + '://' + currentHost + '/files/js/jquery.jqChart.min.js', function () { });
}

function addTR(title, text) {
    return '<tr><td class="title" style="height:35px">' + title + '</td><td>' + text + '</td></tr>';
}

function showChart(chartType, chartInterval) {
    swin.html(ajaxLoading());
    swin.dialog({ title: "主机状态图表", autoOpen: false, resizable: false, width: 768, height: 550, modal: true, buttons: {
        "10分钟": function () { showChart(chartType, 5); },
        "120分钟": function () { showChart(chartType, 60); },
        "24小时": function () { showChart(chartType, 3600); },
        "一个月": function () { showChart(chartType, 86400); },
        "三个月": function () { showChart(chartType, 2592000); },
        "关 闭": function () { $(this).dialog("destroy"); }
    }
    }).dialog("open");
    $.getScript('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=showstat&ctype=' + chartType + '&cinterval=' + chartInterval + '&' + new Date(), function () { });
}

function vmControl(vaction, wtext, otext, exurl) {
    var confirm_box = suwin.find("#confirm_box").prop("checked");
    if (confirm_box == undefined) confirm_box = swin.find("#confirm_box").prop("checked");
    if (!confirm_box) {
        alert('请勾选复选框以确认操作！');
        return false;
    }
    var vcode = suwin.find("input[name='vcode']").val();
    if (vcode == undefined) vcode = swin.find("input[name='vcode']").val();
    if (vcode != undefined) exurl += '&vcode=' + vcode;
    processing(wtext);
    var cmd = 'close';
    var delay = 0;


    $.get('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vmcontrol&vaction=' + vaction + '&' + exurl + '&' + new Date(), function (rdata) {
        var vmsg = rdata.split('|');
        if (vmsg[0] == "0") {
            rdata = otext;
            delay = 3000;
            if (vaction == 'reload') {
                cmd = 'reload';
            }
            else if (vaction == 'backup') {
                if (exurl.indexOf('=revert') > -1) cmd = 'reload';
                else {
                    cmd = 'close';
                    suwin.dialog('close');
                    backup(0);
                }
            }
            else if (vaction == 'portmap') {
                cmd = 'close';
                suwin.dialog('close');
                mPortmap();
            }
            else if (vaction == 'domain') {
                cmd = 'close';
                suwin.dialog('close');
                mDomain();
            }
            else {
                swin.dialog('close');
                showVState();
            }
        } else if (vmsg[0] == "-1") {
            rdata = _pm_showErrMsg(vmsg);
        }

        if (vaction == 'reload') {
            //为此操作更新相关服务名称或者配置
            $.get('?c=module&serviceid=' + serviceData[0].sid + '&productid=' + serviceData[0].pid + '&action=update_service_data&show=text&subaction=' + vaction + '&' + new Date(), function (udata) {
                if (udata != '0') {
                    if (udata.indexOf('-1|')) udata = udata.substring(3);
                    rdata += udata;
                }
                showResults(rdata, delay, cmd);
            });
        }
        else showResults(rdata, delay, cmd);
    });
}

function _pm_showErrMsg(vmsg) {
    var msg = vmsg[1];
    switch (vmsg[1]) {
        case 'VPS not found': msg = '主机并不存在！'; break;
        case 'Server is under maintenance': msg = '您要操作的主机所在服务器节点正在维护中，请稍候重试！'; break;
        case 'Bandwidth overage': msg = '您要操作的主机因流量超用暂停，升级流量后状态将在10分钟内自动恢复！'; break;
        case 'Setup failed': msg = '主机安装过程发生错误，请尝试再次重装或联系客服解决！'; break;
        case 'Locked': msg = '您要操作的主机已被锁定，操作无法继续！'; break;
        case 'Overdue': msg = '您要操作的主机因欠费暂时停用，请于立即充值并进行[手动续费]操作，超过时限系统将自动移除此主机及所有数据！'; break;
        case 'VPS is being installed': msg = '您要操作的主机正在安装设置中，请稍候重试！'; break;
        case 'you do not have access to reload os': msg = '您当前的用户级别不允许“重装系统”操作！'; break;
        case 'OS reload operation has exceeded your level limit [' + vmsg[2] + ']': msg = '您的“系统重装”操作已超过您的用户级别限制“' + vmsg[2] + '”次！'; break;
        case 'The current operation is not allowed': msg = '当前状态不允许此操作，请稍候重试！'; break;
        case 'OS not found': msg = '不允许使用此操作系统模板！'; break;
        case 'Invalid verification code': msg = '操作验证码无效！'; break;
        case "The system time does not match NTP": rdata = '对不起，系统时间有误，请与管理员联系！'; break;
    }
    return msg;
}

function reload(action) {
    swin.html(ajaxLoading());
    $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=getoslist&rt=json&serverid=' + serviceData[0].sconfig.serverid + '&' + new Date(), function (rdata) {
        if (rdata[0].isEmpty == 'true') {
            suwin.html('');
            return false;
        }
        var allowOS = ',' + productData[0].pconfig.allowos + ',';
        var str = '<table style="width:100%" border="0" cellspacing="0" cellpadding="0" class="table">';
        var opath = protocol+'://' + currentHost + '/files/images/os/';
        var ico = '', des = '';
        var odes
        $(rdata).each(function (i) {
            if (allowOS.indexOf(',0,') < 0 && allowOS.indexOf(',' + rdata[i].oid + ',') < 0) return true;
            if (typeof (rdata[i].odes) != 'object') {
                odes = rdata[i].odes.split('|');
                ico = odes[0];
                des = odes[1];
            } else {
                ico = rdata[i].odes.ico;
                des = rdata[i].odes.des;
            }
            str += '<tr class="ost" title="' + rdata[i].oid + '.' + rdata[i].oname + '"><td style="padding:10px 5px 10px 5px;width:39px;"><img src="' + opath + ico + '" alt=""/></td><td style="padding:10px 0px 0px 0px;line-height:21px;"><strong>' + rdata[i].oname + '</strong><br />' + htmlDecode(des) + '</td></tr>';
        });
        str += '</table>';
        swin.html(str);
        swin.find(".ost").css({ "cursor": "pointer" });
        //swin.find(".ost").mouseover(function () { $(this).find("td").css("background", "#EEEEEE"); }).mouseout(function () { $(this).find("td").css("background", "#FFFFFF"); });
        swin.find(".ost").click(function () {
            var vosc = $(this).attr("title").split('.');
            swin.html(ajaxLoading());
            $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=getsysconfig&' + new Date(), function (sysconfig) {

                str = '<div style="line-height:30px;padding:10px">您选择安装的操作系统是：<strong><input type="hidden" value="' + vosc[0] + '" name="vos"/>' + vosc[1] + '</strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" class="button" value="选择其它系统" onclick="reload()"/><br />安装模式：<br />' +
                  '<input type="radio" name="rot" value="1" id="rot_1"/><label for="rot_1">只格式化系统盘：(推荐)</label><br />本选项将重新格式化系统盘分区(一般为C盘或/dev/xvda)，其它分区数据不受影响！<br />' +
                  '<input type="radio" name="rot" value="0" id="rot_0"/><label for="rot_0">全盘格式化模式：</label><br />本选项将彻底删除所有硬盘分区数据，重新建立硬盘系统分区，重装前请确认已备份数据！<br />&nbsp;<br />';

                if (sysconfig.sms_vps_reload == '1' || sysconfig.email_vps_reload == '1') {
                    str += '验证码：<input class="text" style="width:218px" type="text" name="vcode"/>';
                    if (sysconfig.sms_vps_reload == '1') str += ' <input type="button" class="button" onclick="sendVCode(1)" value="发送到手机"/>';
                    if (sysconfig.email_vps_reload == '1') str += ' <input type="button" class="button" onclick="sendVCode(2)" value="发送到邮箱"/>';
                    str += '<br />&nbsp;<br />';
                }

                str += '<input type="checkbox" value="1" id="confirm_box"/><label for="confirm_box">勾选此处以确认重装系统操作！</label><br />-------------------------------------<br />操作前请确认已备份好相关数据，如需要其它操作帮助，请联系客服！</div>';
                str = '<form onsubmit="return false;">' + str + '</form>';

                swin.html(str);
                swin.find("label").css({ "font-weight": "bold", "cursor": "pointer" });
                swin.find("input:radio:first").click();
            });
        });
    });
    swin.dialog({ title: "选择操作系统", autoOpen: false, resizable: false, width: 599, height: 520, modal: true, buttons: { "确定重装": function () { vmControl('reload', '正在执行重装系统任务，请稍候...', '主机[' + serviceData[0].ssid + ']的系统重装进程已经开始！<br /><strong>重装完成后，请您第一时间修改默认密码！</strong>', 'osid=' + swin.find('input[name="vos"]').val() + '&rot=' + swin.find('input[name="rot"]:checked').val()); }, "关 闭": function () { $(this).dialog("close"); } } }).dialog("open");
}

function sendVCode(vtype) {
    processing("正在发送，请稍候......");
    var delay = 0;
    var cmd = 'close';
    $.get('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=sendvcode&vtype=' + vtype + '&' + new Date(), function (rdata) {
        var rmsg = rdata.split('|');
        if (rmsg[0] == "0") {
            rdata = '您的验证码已经发送成功！<br />如2分钟内没有收到验证码，请尝试重发！';
            delay = 8000;
        } else if (rmsg[0] == "-1") {
            switch (rmsg[1]) {
                default: rdata = rmsg[1];break;
            }
        }
        showResults(rdata, delay, cmd);
    });
}


function backup(action) {
    var asnapshot = 0, abackup_full = 0;
    var str = '';
    if (action == 0) {
        swin.html(ajaxLoading());
        var bktype = '';
        var createAble;
        $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vps_fields&ajax_p2=1&rt=json&' + new Date(), function (rdata) {
            str = '<table width="100%" border="0" cellspacing="0" cellpadding="0" class="table">' +
                  '<thead><tr><th>编号</th><th>名称</th><th>类型</th><th>备份时间</th><th>操作系统</th><th>大小</th><th>状态</th><th>&nbsp;</th></tr></thead>';
            if (rdata[0].isEmpty != 'true') {
                $(rdata).each(function (i) {
                    createAble = false;
                    if (rdata[i].fname == 'Snapshot') {
                        bktype = '快照备份';
                        asnapshot++;
                    }
                    else {
                        bktype = '完整备份';
                        abackup_full++;
                        if (rdata[i].fconfig.osid != undefined && rdata[i].fstatus != '0') createAble = true;
                    }
                    str += '<tr id="tr' + rdata[i].fid + '"><td>' + rdata[i].fid + '</td><td title="' + rdata[i].fconfig.backup_name + '">' + rdata[i].fvalue + '</td><td>' + bktype + '</td><td>' + getUnixTime(rdata[i].fconfig.time) + '</td><td>' + (rdata[i].fconfig.os == undefined ? '--' : rdata[i].fconfig.os) + '</td><td>' + (rdata[i].fconfig.vdisk == undefined ? '--' : rdata[i].fconfig.vdisk + 'G') + '</td><td>' + (rdata[i].fstatus == '0' ? '正在创建' : '完成') + '</td><td><input type="button" class="button" name="revert" value="还原"/> <input type="button" name="del" class="button" value="删除"/>' + (createAble ? ' <input type="button" name="createvps" class="button" value="创建主机" title="使用此备份镜像创建新的主机"/>' : '') + '</td></tr>';
                });
            }
            str += '<tfoot><tr><td colspan="8"><div class="bulk-actions align-left">备份记录数：<strong id="asnapshot">' + asnapshot + '</strong>个快照备份， <strong id="abackup_full">' + abackup_full + '</strong>个完整备份</div></td></tr></tfoot></table></div>';

            swin.html(str);
            swin.css("padding","0px");
            swin.find(".button").click(function () {
                var baction = $(this).attr("name");
                var ctr = $(this).parent().parent();

                if (baction == 'createvps') {
                    window.open('?c=order&serviceid=' + serviceData[0].sid + '&pg=' + productData[0].pgid + '&ptype=' + serviceData[0].stype + '&pid=' + productData[0].pid + '&bkid=' + ctr.attr("id").substring(2) + '', '_blank');
                }
                else {
                    var exurl = '';
                    exurl = 'subvaction=' + baction + '&bkid=' + ctr.attr("id").substring(2);
                    suwin.html(ajaxLoading());
                    $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=getsysconfig&' + new Date(), function (sysconfig) {
                        str = '<form><div style="font-weight:bold;padding-top:10px;line-height:30px;">';
                        if (baction == "del") {
                            str += '<br /><input type="checkbox" id="confirm_box" value="1"/><label for="confirm_box" style="cursor:pointer">您确定要删除此备份[' + ctr.find('td:eq(1)').text() + ']吗？</label>';
                        }
                        else if (baction == 'revert') {
                            str += '<input type="checkbox" id="confirm_box" value="1"/><label for="confirm_box" style="cursor:pointer"><span style=";color:#ff0000;">还原备份将会覆盖您现有数据(注:还原完整备份将会覆盖清除现有快照)，您确定已经备份好现有数据并继续还原备份集[' + ctr.find('td:eq(1)').text() + ']吗？</span></label><br />';
                            if (sysconfig.sms_vps_revert == '1' || sysconfig.email_vps_revert == '1') {
                                str += '&nbsp;<br />验证码：<input class="text" style="width:108px" type="text" name="vcode"/>';
                                if (sysconfig.sms_vps_revert == '1') str += ' <input type="button" class="button" onclick="sendVCode(1)" value="发送到手机"/>';
                                if (sysconfig.email_vps_revert == '1') str += ' <input type="button" class="button" onclick="sendVCode(2)" value="发送到邮箱"/>';
                            }
                        }
                        str += '</div></form>';
                        suwin.html(str);
                    });
                    suwin.dialog({ title: '操作确认', autoOpen: false, resizable: false, width: 500, height: 278, modal: true, buttons: { '确 定': function () { vmControl('backup', '正在处理，请稍候...', '操作成功！', exurl); }, '取 消': function () { $(this).dialog("close"); } } }).dialog("open");
                }
            });
        });
        swin.dialog({ title: '备份/还原主机', autoOpen: false, resizable: false, width: 900, height: 500, modal: true, buttons: { '创建备份': function () { backup(1); }, '购买更多备份空间': function () { upgrade(0); }, '关 闭': function () { $(this).dialog("close"); } } }).dialog("open");
    }
    else if (action == 1) {
        asnapshot = serviceData[0].sconfig.backup_snapshot == undefined ? 0 : parseInt(serviceData[0].sconfig.backup_snapshot);
        abackup_full = serviceData[0].sconfig.backup_full == undefined ? 0 : parseInt(serviceData[0].sconfig.backup_full);
        if (asnapshot > 0) asnapshot = (asnapshot - parseInt(swin.find("#asnapshot").text()));
        else asnapshot = 0;
        if (abackup_full > 0) abackup_full = (abackup_full - parseInt(swin.find("#abackup_full").text()));
        else abackup_full = 0;
        suwin.html(ajaxLoading());
        $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=getusergroup&' + new Date(), function (usergroup) {
            str = '<form action="?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vmcontrol&vaction=backup&subvaction=backup" onsubmit="return backup(2);"><div style="line-height:35px;">' +
                '<strong>备份集名称：</strong><input class="text" name="bkname" class="text-input" value=""/> 50个字符以内<br />' +
                '<strong>备份集类型：</strong><input type="radio" checked="checked" name="bktype" value="0" id="bt_0"><label for="bt_0">快照备份(本地)</label>&nbsp;&nbsp;&nbsp;<input type="radio" name="bktype" value="1" id="bt_1"><label for="bt_1">完整备份(异地)</label> <br />' +
                '<strong>您还可创建：</strong><strong>' + asnapshot + '</strong>个快照备份，<strong>' + abackup_full + '</strong>个完整备份<br />' +
                '<strong>每天允许执行完整备份和还原的时间集(小时)：</strong>' + usergroup[0].utconfig.backup_hours + '<br />'
                '</div></form>';
            suwin.html(str);
        });
        suwin.dialog({ title: '创建备份', autoOpen: false, resizable: false, width: 500, height: 299, modal: true, buttons: { '确定(Ctrl+Enter)': function () { backup(2); }, '关 闭': function () { $(this).dialog("close"); } } }).dialog("open");
    }
    else if (action == 2) {
        var cform = suwin.find("form:first");
        var delay = 0;
        var cmd = '';
        processing('正在处理，请稍候...');
        $.post(cform.attr("action"), cform.serialize(), function (rdata) {
            var rmsg = rdata.split('|');
            if (rmsg[0] == '0') {
                rdata = '备份创建成功！';
                delay = 3000;
                cmd = 'close';
                suwin.dialog("close");
                backup(0);
            }
            else if (rmsg[0] == '-1') {
                switch (rmsg[1]) {
                    default: rdata = rmsg[1];
                }
            }
            showResults(rdata, delay, cmd);
        });
        return false;
    }
}

function viewPS() {
    ViewService.find("#defaultps").text('正在读取，请稍候...');
    $.get('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vmcontrol&vaction=defaultps&' + new Date(), function (rdata) {
        if (rdata == 'installing') rdata = '系统正在安装及生成密码，请稍候重试！';
        ViewService.find("#defaultps").text(rdata);
    });
}

function resetPS(action) {
    if (action == 0) {
        var str = '';
        swin.html(ajaxLoading());
        $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=getsysconfig&' + new Date(), function (sysconfig) {
            if (os_template == 'XS_TP_Windows_Ver_2') {
                str += '<strong>用户名：</strong><input class="text" value="administrator" style="width:200px" type="text" name="username"/><br />' +
                       '<strong>密　码：</strong><input class="text" style="width:200px" type="password" name="password"/><br />';
            }
            else str = '<strong>重置操作系统管理员用户（Administrator/Root）的密码需要重启主机，您确定执行操作吗？</strong><br />';

            if (sysconfig.sms_vps_reset_password == '1' || sysconfig.email_vps_reset_password == '1') {
                str += '<strong>验证码：</strong><input class="text" style="width:200px" type="text" name="vcode"/>';
                if (sysconfig.sms_vps_reset_password == '1') str += ' <input type="button" class="button" onclick="sendVCode(1)" value="发短信到手机"/>';
                if (sysconfig.email_vps_reset_password == '1') str += ' <input type="button" class="button" onclick="sendVCode(2)" value="发到邮箱"/>';
                str += '<br />';
            }
            str += '<input type="checkbox" value="1" id="confirm_box" checked="checked" style="display:none"/></div>';
            str = '<form  action="?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vmcontrol&vaction=resetps" style="line-height:39px;padding:10px;">' + str + '</form>';
            swin.html(str);
        });

        swin.dialog({ title: '重置密码', autoOpen: false, resizable: false, width: 588, height: 270, modal: true, buttons: { '确定(Ctrl+Enter)': function () { resetPS(1); }, '取消': function () { $(this).dialog("close"); } } }).dialog("open");
    } else {
        if (!swin.find("#confirm_box").prop("checked")) {
            alert('请勾选复选框以确认操作！');
            return false;
        }

        var cform = swin.find("form:first");
        var delay = 0;
        var cmd = '';
        processing('正在处理，请稍候...');
        $.post(cform.attr("action"), cform.serialize(), function (rdata) {
            var rmsg = rdata.split('|');
            if (rmsg[0] == '0') {
                rdata = '操作成功！';
                delay = 5000;
                cmd = 'reload';
            }
            else if (rmsg[0] == '-1') {
                switch (rmsg[1]) {
                    default: rdata = rmsg[1];
                }
            }
            showResults(rdata, delay, cmd);
        });
        return false;
    }
}

function cvif(action) {
    swin.html('<table width="100%" border="0" cellspacing="0" cellpadding="0" class="table">' +
              '<thead><tr><th>编号</th><th>MAC</th><th>网络</th><th>状态</th><th>&nbsp;</th></tr></thead><tbody id="viflist"><tr><td colspan="5">' + ajaxLoading() + '<br />&nbsp;</td></tr></tbody>' +
             '</table></div>');
    swin.css("padding", "0px");
    var vifList = swin.find("#viflist");
    $.get('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vmcontrol&vaction=vif&subvaction=list&' + new Date(), function (rdata) {
        var rmsg = rdata.split('|');
        if (rmsg[0] == "-1") {
            vifList.find("td:first").html(rmsg[1]);
        }
        else {
            vifList.find("tr").remove();
            var vifs = $.parseJSON(rdata);
            var vc = parseInt(vifs.count);
            var vfstatus, vfbtn;
            for (i = 1; i <= vc; i++) {
                if (vifs["status_" + i] == '1') {
                    vfstatus = '<strong>已启用</strong>';
                    vfbtn = '<input type="button" id="' + vifs["id_" + i] + '" name="btn_unplug" value="禁用" class="button"/>';
                }
                else {
                    vfstatus = '已禁用';
                    vfbtn = '<input type="button" id="' + vifs["id_" + i] + '" name="btn_plug" value="启用" class="button"/>';
                }
                vifList.append('<tr><td class="center">' + i + '</td><td class="vmac">' + vifs["mac_" + i].toUpperCase() + '</td><td>' + vifs["network_" + i] + '</td><td>' + vfstatus + '</td><td>' + vfbtn + '</td></tr>');
            }
            vifList.find(".button").click(function () {
                processing('正在处理，请稍候...');
                var cmd = 'close';
                var delay = 0;
                $.post('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vmcontrol&vaction=vif&subvaction=' + $(this).attr("name").substring(4) + '&' + new Date(), { "vfid": $(this).attr("id") }, function (rdata) {
                    var rmsg = rdata.split('|');
                    if (rmsg[0] == "0") {
                        rdata = '操作成功！系统需要大概20秒时间重置状态，您可以尝试ping IP地址来检测是否成功！';
                        setTimeout("cvif();", 20000);
                        delay = 20000;
                    }
                    else rdata = rmsg[1];
                    showResults(rdata, delay, cmd);
                });
            });
        }
        if (os_template != '') swin.dialog("option", "buttons", { '关闭': function () { $(this).dialog("close"); }, '绑定IP地址': function () { setIPs(0); } });
    });
    swin.dialog({ title: '网卡控制', autoOpen: false, resizable: false, width: 520, height: 350, modal: true, buttons: { '关闭': function () { $(this).dialog("close"); } } }).dialog("open");
}

function setIPs(action) {
    if (action == 0) {
        suwin.html(ajaxLoading());

        $.getJSON("?c=module&serviceid=" + serviceData[0].sid + "&action=custom_action&show=text&subaction=ip&rt=json&" + new Date(), function (rdata) {

            var str = '<form id="ipform"><table width="100%" border="0" cellspacing="0" cellpadding="0" class="table"><thead><tr>';
            var macs = swin.find(".vmac");
            var nc = macs.length;
            var _mac;
            $(macs).each(function (i) {
                _mac = $(macs[i]).text();
                str += '<th>网卡[' + _mac + ']<input type="hidden" name="mac_' + i + '" value="' + _mac + '"></th>';
            });
            str += '</tr></thead><tbody>';

            if (rdata[0].isEmpty != 'true') {
                $(rdata).each(function (i) {
                    str += '<tr>';
                    for (n = 0; n < nc; n++) str += '<td><label><input type="radio" name="ip_' + rdata[i].ip + '" value="' + n + '">' + rdata[i].ip + '</label></td>';
                    str += '</tr>';
                });
                str += '<tr>';
                for (n = 0; n < nc; n++) str += '<td><label><input type="radio" name="ip_dhcp" value="' + n + '">DHCP自动获取</label></td>';
                str += '</tr>';
            }
            str += '</tr></tbody><tfoot><tr><td colspan="' + nc + '"><input type="hidden" name="nicCount" value="' + nc + '"/><strong>温馨提示：</strong>同个网卡仅能绑定相同IP段的IP，双击可取消IP选择</td></tr></tfoot></table></form>';
            suwin.html(str);
            suwin.css("padding", "0px");
            suwin.find("label").dblclick(function () {
                $(this).find("input").prop("checked", false);
            });
        });

        suwin.dialog({ title: '绑定IP地址', autoOpen: false, resizable: false, width: 768, height: 500, modal: true, buttons: { '确定': function () { setIPs(1); }, '取消': function () { $(this).dialog("close"); } } }).dialog("open");
    }
    else {
        confirmMsg('操作确认', '您确定要将选择的IP绑定到当前主机中吗？<br />此操作可能需要重启主机！', function () {
            processing('正在处理，请稍候...');
            var delay = 0;
            var cmd = '';
            var cform = suwin.find("#ipform");
            $.post('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=vmcontrol&vaction=setips&' + new Date(), cform.serialize(), function (rdata) {
                var rmsg = rdata.split('|');
                if (rmsg[0] == '0') {
                    rdata = '操作成功，请等待系统完成IP绑定任务后，确认IP是否绑定成功！';
                    delay = 3000;
                    cmd = 'close';
                }
                else if (rmsg[0] == '-1') {
                    switch (rmsg[1]) {
                        default: rdata = rmsg[1];
                    }
                }
                showResults(rdata, delay, cmd);
            });
        });
    }
}


function BWList() {
    swin.html(ajaxLoading());
    $.getJSON("?c=module&serviceid=" + serviceData[0].sid + "&action=custom_action&show=text&subaction=bwlist&rt=json&" + new Date(), function (rdata) {
        var str = '';
        if (rdata[0].isEmpty == 'true') str = '暂无历史周期流量';
        else {
            str = '<table width="100%" border="0" cellspacing="0" cellpadding="0" class="table"><tr><th style="width:100px;">开始时间</th><th style="width:100px;">结束时间</th><th>使用的流量</th></tr>';
            $(rdata).each(function (i) {
                str += '<tr><td>' + rdata[i].sdate.substring(0, rdata[i].sdate.indexOf(' ')) + '</td><td>' + rdata[i].edate.substring(0, rdata[i].edate.indexOf(' ')) + '</td><td>' + parseFloat(parseInt(rdata[i].bw) / 1024 / 1024 / 1024).toFixed(2) + ' GB</td></tr>';
            });
            str += '</table>';
        }
        swin.html(str);
        swin.find(".table").parent().css("padding", "0px");
        swin.find("td").css("height", "25px");
    });
    swin.dialog({ title: "查看历史流量", autoOpen: false, resizable: false, width: 399, height: 299, modal: true, buttons: { "关 闭": function () { $(this).dialog("close"); } } }).dialog("open");
}

function mIPs() {
    swin.html(ajaxLoading());
    var ipmax = parseInt(productData[0].pupgrade.ip_max);
    var ipPrice = parseFloat(productData[0].pupgrade.ip);
    var ip_discount = productData[0].pupgrade.ip_discount == undefined ? 0 : productData[0].pupgrade.ip_discount;
    if (ip_discount == '1') ipPrice = ipPrice * productDiscount;

    $.getJSON("?c=module&serviceid=" + serviceData[0].sid + "&action=custom_action&show=text&subaction=ip&rt=json&" + new Date(), function (rdata) {
        if (rdata[0].isEmpty == 'true') {
            swin.html("IP地址信息获取错误！");
            return false;
        }
        var str = '<strong>IP地址列表：</strong>(点击IP查看网关等信息)<br />';
        $(rdata).each(function (i) { str += '<span name="' + rdata[i].bid + '">' + rdata[i].ip + '</span><br />'; });
        ipmax = ipmax - $(rdata).length;
        str += ' <br />您还可以为此主机添加<strong>' + ipmax + '</strong>个IP，每个<strong>' + ipPrice.toFixed(2) + '</strong>元，帐户余额：<strong>' + parseFloat(userData[0].balance).toFixed(2) + ' ' + userData[0].currency + '</strong><br />' +
                    '增加IP地址数：<input class="text center" style="width:50px" id="ipcount" value="1"/>个 X <strong>' + ipPrice.toFixed(2) + '</strong>元　　<input class="button" type="button" value="立即购买"/><br />' +
                    '最终费用按您的主机续费时间计算';
        swin.html('<div style="line-height:21px;padding:10px">' + str + '</div>');
        swin.find("span").css("cursor", "pointer").click(function () {
            var ipspan = $(this);
            var iptext = ipspan.text();
            if (iptext.indexOf(' ') > 0) iptext = iptext.substring(0, iptext.indexOf(' '));
            ipspan.text(iptext + ' 正在查询，请稍候...');
            $.getJSON("?c=module&serviceid=" + serviceData[0].sid + "&action=custom_action&show=text&subaction=ipblock&rt=json&blockid=" + ipspan.attr("name") + "&" + new Date(), function (rdata) {
                if (rdata[0].isEmpty == 'true') iptext = iptext + " 网关信息获取失败！";
                else {
                    iptext = '<strong>' + iptext + '</strong>&nbsp;&nbsp;&nbsp;网关地址：' + rdata[0].gateway + '&nbsp;&nbsp;&nbsp;子网掩码：' + rdata[0].netmask;
                    ipspan.css("cursor", "normal").unbind("click");
                }
                ipspan.html(iptext);
            });
        });
        swin.find(".button:last").click(function () {
            var ipcount = parseInt(swin.find("#ipcount").val());
            var totalPrice = ipcount * ipPrice * remainingTime;
            if (ipcount > ipmax) alert("您最多还可为此主机添加" + ipmax + "个IP地址，如需要更多IP地址请与客服联系！");
            else {

                var str = '购买IP地址确认：\r\nIP地址数：' + ipcount + '个\r\n　IP单价：' + ipPrice.toFixed(2) + '元/' + getTimeCycleSuffix(0, timeCycle, 0) + '\r\n付费周期：' + remainingTime + getTimeCycleSuffix(0, timeCycle, 1) + '\r\n';

                str += '本次费用：' + totalPrice.toFixed(2) + ' ' + userData[0].currency;
                if (confirm(str)) {
                    var delay = 0;
                    var cmd = '';
                    processing("正在处理，请稍候......");
                    $.get('?c=module&serviceid=' + serviceData[0].sid + '&action=upgrade_service&subaction=ips&ipcount=' + ipcount + '&show=text&' + new Date(), function (rdata) {
                        var rmsg = rdata.split('|');
                        if (rmsg[0] == "0") {
                            rdata = "IP购买成功，请手动将新IP添加到您的主机！";
                            setTimeout("mIPs();", 3000);
                            delay = 3100;
                            cmd = 'close';
                        }
                        else {
                            switch (rmsg[1]) {
                                case "The system time does not match NTP": rdata = '对不起，系统时间有误，请与管理员联系！'; break;
                                default: rdata = rmsg[1]; break;
                            }
                        }
                        showResults(rdata, delay, cmd);
                    });
                }
            }
        });
    });
    swin.dialog({ title: "管理主机IP地址", autoOpen: false, resizable: false, width: 578, height: 378, modal: true, buttons: { "网卡控制 & 绑定IP地址": function () { cvif(); }, "关 闭": function () { $(this).dialog("destroy"); } } }).dialog("open");
}



var finalPrice = 0;
var normalPrice = 0;
var productID = productData[0].pid;
var billingMothod = parseInt(serviceData[0].spmothod);
var billingCycle = 1;
function _pm_renew(action) {
    if (billingMothod != 1) {
        alert("您当前服务无需续费！");
        return false;
    }
    var cycles = productData[0].pprice.cycle.split(',');
    var cprices = productData[0].pprice.cprice.split(',');
    var ipMin = productData[0].pconfig.ipc == undefined ? 1 : parseInt(productData[0].pconfig.ipc);

    var config_ram_max = productData[0].pconfig.ram == undefined ? '0' : productData[0].pconfig.ram;
    config_ram_max = productData[0].pconfig.ram_max == undefined ? config_ram_max : productData[0].pconfig.ram_max;

    var addprice = (parseFloat(serviceData[0].sconfig.vcpu) - parseFloat(productData[0].pconfig.cpu)) * parseFloat(productData[0].pupgrade.cpu_price) / parseFloat(productData[0].pupgrade.cpu_step);
    addprice += (parseFloat(currentRam) - parseFloat(config_ram_max)) * parseFloat(productData[0].pupgrade.ram_price) / parseFloat(productData[0].pupgrade.ram_step);
    addprice += (parseFloat(serviceData[0].sconfig.vdisk) - parseFloat(productData[0].pconfig.disk)) * parseFloat(productData[0].pupgrade.disk_price) / parseFloat(productData[0].pupgrade.disk_step);
    addprice += (parseFloat(serviceData[0].sconfig.vbandwidth) - parseFloat(productData[0].pconfig.bw)) * parseFloat(productData[0].pupgrade.bw_price) / parseFloat(productData[0].pupgrade.bw_step);
    if (productData[0].pconfig.port != '0') {
        var addprice_vport = parseFloat(serviceData[0].sconfig.vport);
        if (addprice_vport == 0) addprice_vport = parseFloat(productData[0].pupgrade.port_max);
        addprice += (addprice_vport - parseFloat(productData[0].pconfig.port)) * parseFloat(productData[0].pupgrade.port_price) / parseFloat(productData[0].pupgrade.port_step);
    }
    addprice += (parseFloat(serviceData[0].sconfig.ipcount) - ipMin) * parseFloat(productData[0].pupgrade.ip);
    var addprice_snapshot = serviceData[0].sconfig.backup_snapshot == undefined ? 0 : parseInt(serviceData[0].sconfig.backup_snapshot);
    if (addprice_snapshot > 0) {
        addprice += (addprice_snapshot - parseInt(productData[0].pconfig.snapshot)) * parseFloat(productData[0].pupgrade.snapshot_price);
    }
    var addprice_full_backup = serviceData[0].sconfig.backup_full == undefined ? 0 : parseInt(serviceData[0].sconfig.backup_full);
    if (addprice_full_backup > 0) {
        addprice += (addprice_full_backup - parseInt(productData[0].pconfig.full_backup)) * parseFloat(productData[0].pupgrade.full_backup_price);
    }

    if (addprice < 0) addprice = 0;

    var str = '<div style="line-height:25px"><strong>请选择续费周期</strong>：<br />';

    var cprice = 0, yprice = 0, pp1 = 0, pp2 = 0;
    for (i = 0; i < cycles.length; i++) {
        if (cprices[i] != '0') {
            cprice = parseFloat(addprice * parseFloat(cycles[i]) + parseFloat(cprices[i]));
            yprice = cprice;
            if (cycles[i] == serviceData[0].spcycle) cprice = serviceData[0].sprice;
            else {
                if (productDiscount > 1) {
                    cprice = cprice * productDiscount;
                }
            }
            if (pp1 == 0) pp1 = parseFloat(yprice) / parseInt(cycles[i]);
            else {
                pp2 = (parseFloat(yprice) / parseInt(cycles[i]) / pp1 * 10).toFixed(1);
            }
            str += '<label id="cycle' + cycles[i] + '"><input type="radio" name="cycle" value="' + cycles[i] + '_' + cprice + '_' + yprice + '" />' +
                   parseFloat(cprice).toFixed(2) + ' / ' + getTimeCycleSuffix(cycles[i], timeCycle, 1) + (pp2 != 0 ? ' (' + pp2 + '折)' : '') + '</label><br />';

        }
    }
    str += '&nbsp;<br />帐户余额：<strong>' + parseFloat(userData[0].balance).toFixed(2) + '</strong> ' + userData[0].currency;
    if (productDiscount < 1) str += '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>帐户优惠</strong>：<strong style="color:#0000FF">' + (productDiscount * 100 / 10) + '</strong>折';
    str += '<br />续费价格：<strong class="finalPrice"></strong> ' + userData[0].currency + '&nbsp;&nbsp;&nbsp;<span class="normalPrice"></span><br />&nbsp;<br />' +
           '<span>优 惠 码：<input class="text" id="couponcode" style="width:100px"/> <input type="button" class="button" value="使用" onclick="applyCode(\'renew\')"/> <input type="button" class="button" value="不使用" onclick="clearCouponCode(1)"/></span><br />' +
           '<span id="ccdes" class="pptext"></span></div>';

    suwin.html(str);
    suwin.dialog({ title: "续费确认", autoOpen: false, resizable: false, width: 500, height: 430, modal: true, buttons: { "确认续费": function () { renew(serviceData[0].sid, billingCycle, $("#couponcode").val()); }, "关 闭": function () { $(this).dialog("close"); } } }).dialog("open");
    suwin.find("input:radio").click(function () {
        clearCouponCode(1);
        var ps = $(this).val().split('_');
        billingCycle = parseInt(ps[0]);
        finalPrice = parseFloat(ps[1]);
        normalPrice = parseFloat(ps[2]);
        if (billingCycle != parseInt(serviceData[0].spcycle) && productDiscount < 1) finalPrice = finalPrice * productDiscount;
        suwin.find(".finalPrice").html(finalPrice.toFixed(2));
    });
    suwin.find("#cycle" + serviceData[0].spcycle).css("font-weight", "bold").find("input").click();
}

function showVState() {
    ViewService.find("#vstatus").html("Checking......");
    $.get("?c=module&serviceid=" + serviceData[0].sid + "&action=custom_action&show=text&subaction=vmcontrol&vaction=state&" + new Date(), function (rdata) {
        var vpsStatus = rdata.split('|');
        var stext = "";
        if (vpsStatus[0] == "0" && vpsStatus[1] == "-1") {
            stext = vpsStatus[2];
            vpsStatus[1] = 'error';
            ViewService.find("#bwusage").html(stext);
        }
        else {
            if (vpsStatus[0] == "-2" || vpsStatus[0] == "-1") {
                vpsStatus[1] = "setup";
                stext = serviceStatus[parseInt(vpsStatus[0]) + 2];
            }
            else if (vpsStatus[0] == "1" || vpsStatus[0] == "2") vpsStatus[1] = "locked";
            else if (vpsStatus[0] == "4") vpsStatus[1] = "overdue";

            switch (vpsStatus[1]) {
                case "setup":
                    if (stext == "") stext = "正在安装配置中...";
                    break;
                case "setupfailed":
                    stext = "系统安装时发生错误，请尝试再次重装或联系客服！";
                    break;
                case "locked":
                    stext = "停机锁定状态，请与客服联系！";
                    break;
                case "halted":
                    stext = '关机状态';
                    break;
                case "running":
                    stext = '正在运行中';
                    if (vpsStatus[0] == "3") stext += ' <strong style="color:#ec5f00">即将到期，请尽快续费！</strong>';
                    break;
                case "overdue":
                    stext = '<strong style="color:#FF0000">欠费停机，请立即充值并进行续费！</strong>';
                    break;
                case "overbw":
                    stext = "<strong style=\"color:#FF0000\">超流量状态，升级增加可用流量后10分钟内自动恢复！</strong>";
                    break;
                default:
                    vpsStatus[1] = "unknown";
                    stext = "未知状态";
                    break;
            }
            if (vpsStatus[2].substring(0, 1) != '{') vpsStatus[2] = '{}';
            var stateParams = $.parseJSON(vpsStatus[2]);
            var vos = stateParams.vos == undefined ? serviceData[0].sconfig.vos : stateParams.vos;
            ViewService.find("#vos").html(vos);

            var bwusage = isNaN(stateParams.bwusage) ? 0 : parseFloat(stateParams.bwusage).toFixed(3);
            if (serviceData[0].sconfig.vbandwidth != '0') {
                ViewService.find("#bwusage").html('<ul id="vbar"><li style="width:218px;padding-top:5px"><div style="height:18px;"></div></li><li></li></ul>');
                var bwur = bwusage / parseFloat(serviceData[0].sconfig.vbandwidth) * 100;
                $("#vbar li").css({ "float": "left" });
                $("#vbar li:last").css("padding-left", "8px").html("已使用" + bwusage + "G，剩余" + (100 - bwur).toFixed(2) + "%　<a href=\"javascript:BWList()\">『查看历史流量』</a>");
                $("#vbar div").progressbar({ value: bwur });
            } else ViewService.find("#bwusage").html('当前主机已使用 <strong>' + bwusage + ' GB</strong> 流量<span><a href=\"javascript:BWList()\">『查看历史流量』</a></span>');

            if (stateParams.backuptask == '4') stext += '&nbsp;&nbsp;&nbsp;<strong style=\"color:#008000\">(正在备份主机)</srtong>';
            else if (stateParams.backuptask == '5') stext += '&nbsp;&nbsp;&nbsp;<strong style=\"color:#008000\">(正在将备份集还原到主机)</strong>';
        }
        ViewService.find("#vstatus").html('<img src="' + protocol + '://' + currentHost + '/files/images/status_' + vpsStatus[1] + '.png" alt="" />&nbsp;' + stext + '&nbsp;&nbsp;&nbsp;<a href="javascript:showVState();">[刷新状态]</a>');

    });
}

function upgrade(action) {
    if (action == 0) {
        if (serviceData[0].spmothod != "1") {
            alert('您当前服务不支持升级操作！');
            return false;
        }
        var duedate = getUnixTime(parseInt(serviceData[0].etime));
        duedate = duedate.substring(0, duedate.indexOf(' '));

        var snapshotMin = serviceData[0].sconfig.backup_snapshot == undefined ? 0 : parseInt(serviceData[0].sconfig.backup_snapshot);
        var snapshotMax = productData[0].pupgrade.snapshot_max == undefined ? 0 : parseInt(productData[0].pupgrade.snapshot_max);
        if (snapshotMax < snapshotMin) snapshotMax = snapshotMin;
        var fullBackupMin = serviceData[0].sconfig.backup_full == undefined ? 0 : parseInt(serviceData[0].sconfig.backup_full);
        var fullBackupMax = productData[0].pupgrade.full_backup_max == undefined ? 0 : parseInt(productData[0].pupgrade.full_backup_max);
        if (fullBackupMax < fullBackupMin) fullBackupMax = fullBackupMin;

        var str = '<form id="uform"><div style="line-height:21px;">' +
              '<p>&nbsp;CPU数量(核)：<input class="vcvalue" type="text" name="vcpu"/><span class="ptext"></span></p><div id="sl_cpu"></div>' +
              '<p>内存大小(MB)：<input class="vcvalue" type="text" name="vram"/><span class="ptext"></span></p><div id="sl_ram"></div>' +
              '<p>硬盘容量(GB)：<input class="vcvalue" type="text" name="vdisk"/><span class="ptext"></span></p><div id="sl_disk"></div>' +
              '<p>带宽流量(GB)：<input class="vcvalue" type="text" name="vbw"/><span class="ptext"></span></p><div id="sl_bw"></div>' +
              '<p>网络端口(Mb)：<input class="vcvalue" type="text" name="vport"/><span class="ptext"></span></p><div id="sl_port"></div>' +
              '<p>可用备份集：快照:<select class="price_select" name="snapshot">';
        for (i = snapshotMin; i <= snapshotMax; i++) str += '<option value="' + i.toString() + '">' + i.toString() + '个</option>';
        str += '</select> <span class="snapshot_price"></span>&nbsp;&nbsp;&nbsp;完整备份:<select class="price_select" name="full_backup">';
        for (i = fullBackupMin; i <= fullBackupMax; i++) str += '<option value="' + i.toString() + '">' + i.toString() + '个</option>';
        str += '</select> <span class="full_backup_price"></span>';
        
        str += '</p>' +
              '<p>下次续费日期：<input class="vctext" type="text" value="' + duedate + '"/>本次升级周期：<strong>' + remainingTime + '</strong>' + getTimeCycleSuffix(0, timeCycle, 1) + '&nbsp;&nbsp;&nbsp;余额：<strong>' + parseFloat(userData[0].balance).toFixed(2) + ' ' + userData[0].currency + '</strong></p>' +
              '<p>标准升级费用：<input class="vctext" type="text" name="muprice"/>本次升级费用：<span style="font-weight:bold;padding-right:8px" title="到下个计费周期所剩时间的升级费用，也是您本次需要支付的费用！" class="finalPrice">Loading...</span><span class="normalPrice"></span></p>' +
              '<p><span>优 惠 码：<input class="text" id="couponcode" style="width:100px"/> <input type="button" class="button" value="使用" onclick="applyCode(\'upgrade\')"/> <input type="button" class="button" value="不使用" onclick="clearCouponCode(1)"/></span> ' +
              '<span id="ccdes" class="pptext"></span></p>' +
              '</div></form>';

        suwin.html(str);
        vcpu = suwin.find("input[name='vcpu']");
        vram = suwin.find("input[name='vram']");
        vdisk = suwin.find("input[name='vdisk']");
        vbw = suwin.find("input[name='vbw']");
        vport = suwin.find("input[name='vport']");
        suwin.find("p").css("padding-top", "12px");
        suwin.find(".vcvalue").attr("readonly", "readonly").css({ "border": "0px", "width": "80px", "font-weight": "bold" });
        suwin.find(".vctext").attr("readonly", "readonly").css("border", "0px").css("width", "130px").css("font-weight", "bold");
        suwin.dialog({ title: "升级主机配置", autoOpen: false, resizable: false, width: 658, height: 569, modal: true, buttons: { "立即升级": function () { upgrade(1); }, "取 消": function () { $(this).dialog("close"); } } }).dialog("open");
        _pm_setData();
    }
    else {
        var cmd = '';
        var delay = 0;
        processing("正在进行升级操作，请稍候......");
        var couponCode = suwin.find("#couponcode").val();
        $.post('?c=module&serviceid=' + serviceData[0].sid + '&couponcode=' + couponCode + '&action=upgrade_service&subaction=basic&show=text&' + new Date(), $("#uform").serialize(), function (rdata) {
            var rmsg = rdata.split('|');
            if (rmsg[0] == '0') {
                rdata = "<strong>升级成功！</strong>";
                delay = 3000;
                cmd = 'reload';
            }
            else {
                switch (rmsg[1]) {
                    case "Invalid coupon code": rdata = '您输入的优惠码无效！'; break;
                    case "Lack of balance": rdata = '您的余额不足于购买当前产品！'; break;
                    case "The system time does not match NTP": rdata = '对不起，系统时间有误，请与管理员联系！'; break;
                    default: rdata = getCouponError(rmsg, couponCode); break;
                }
            }
            showResults(rdata, delay, cmd);
        });
    }
}

function _pm_setData() {
    var pdata = productData[0];
    var sconfig = serviceData[0].sconfig;
    $.getJSON('?c=module&serviceid=' + serviceData[0].sid + '&action=custom_action&show=text&subaction=getserverconfig&' + new Date(), function (sdata) {
        var mincpu = parseFloat(sconfig.vcpu);
        var maxcpu = parseFloat(pdata.pupgrade.cpu_max);
        if (maxcpu > parseInt(sdata[0].maxcpu)) maxcpu = parseInt(sdata[0].maxcpu);
        var cpu_step = parseFloat(pdata.pupgrade.cpu_step);
        var cpu_price = parseFloat(pdata.pupgrade.cpu_price);

        var minram = parseFloat(currentRam);
        var maxram = parseFloat(pdata.pupgrade.ram_max);
        var allowram = parseFloat(sdata[0].allowram) + minram;
        if (allowram < maxram) maxram = allowram;
        if (maxram < minram) maxram = minram;
        var ram_step = parseFloat(pdata.pupgrade.ram_step);
        var ram_price = parseFloat(pdata.pupgrade.ram_price);

        var mindisk = parseFloat(sconfig.vdisk);
        var maxdisk = parseFloat(pdata.pupgrade.disk_max);
        var allowdisk = parseFloat(sdata[0].allowdisk) + mindisk;
        if (allowdisk < maxdisk) maxdisk = allowdisk;
        if (maxdisk < mindisk) maxdisk = mindisk;
        var disk_step = parseFloat(pdata.pupgrade.disk_step);
        var disk_price = parseFloat(pdata.pupgrade.disk_price);


        var minbw = parseFloat(sconfig.vbandwidth);
        var maxbw = parseFloat(pdata.pupgrade.bw_max);
        var bw_step = parseFloat(pdata.pupgrade.bw_step);
        var bw_price = parseFloat(pdata.pupgrade.bw_price);

        var minport = parseFloat(sconfig.vport);
        var maxport = parseFloat(pdata.pupgrade.port_max);
        var port_step = parseFloat(pdata.pupgrade.port_step);
        var port_price = parseFloat(pdata.pupgrade.port_price);

        var snapshot_price = pdata.pupgrade.snapshot_price == undefined ? 0 : parseFloat(pdata.pupgrade.snapshot_price);
        var full_backup_price = pdata.pupgrade.full_backup_price == undefined ? 0 : parseFloat(pdata.pupgrade.full_backup_price);

        var cpup = cpu_price / cpu_step;
        var ramp = ram_price / ram_step;
        var diskp = disk_price / disk_step;
        var bwp = bw_price / bw_step;
        var portp = port_price / port_step;
        if (productDiscount > 1) {
            cpup = cpup * productDiscount;
            ramp = ramp * productDiscount;
            diskp = diskp * productDiscount;
            bwp = bwp * productDiscount;
            portp = portp * productDiscount;
            snapshot_price = snapshot_price * productDiscount;
            full_backup_price = full_backup_price * productDiscount;
        }
        suwin.find(".ptext:eq(0)").html("　" + cpup.toFixed(2) + "元/核，最多" + maxcpu + "核");
        suwin.find(".ptext:eq(1)").html(ramp.toFixed(2) + "元/MB,最多" + maxram + "MB");
        suwin.find(".ptext:eq(2)").html(diskp.toFixed(2) + "元/GB,最多" + maxdisk + "GB");
        if (pdata.pconfig.bw == '0') {
            minbw = 0;
            maxbw = 0;
        }
        suwin.find(".ptext:eq(3)").html((maxbw == 0 ? '不限流量' : bwp.toFixed(2) + "元/GB,最多" + maxbw + "GB/月"));
        suwin.find(".ptext:eq(4)").html(portp.toFixed(2) + "元/Mb,最多" + maxport + "Mbps");
        suwin.find(".snapshot_price").html('单价：' + snapshot_price + '元/个');
        suwin.find(".full_backup_price").html('单价：' + full_backup_price + '元/个');

        _pm_sliderIt(mincpu, maxcpu, cpu_step, cpu_price, minram, maxram, ram_step, ram_price, mindisk, maxdisk, disk_step, disk_price, minbw, maxbw, bw_step, bw_price, minport, maxport, port_step, port_price);

        suwin.find(".price_select").change(function () {
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        });
    });
}

function _pm_sliderIt(mincpu, maxcpu, cpu_step, cpu_price, minram, maxram, ram_step, ram_price, mindisk, maxdisk, disk_step, disk_price, minbw, maxbw, bw_step, bw_price, minport, maxport, port_step, port_price) {
    $("#sl_cpu").slider({
        range: "min",
        value: mincpu,
        min: 0,
        max: maxcpu,
        step: cpu_step,
        slide: function (event, ui) {
            vcpu.val(ui.value);
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        },
        stop: function (event, ui) {
            if (parseInt(ui.value) < mincpu) {
                $("#sl_cpu").slider("value", mincpu);
                vcpu.val(mincpu);
            }
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        }
    });
    vcpu.val(mincpu);
    $("#sl_cpu").slider("value", mincpu);

    $("#sl_ram").slider({
        range: "min",
        value: minram,
        min: 0,
        max: maxram,
        step: ram_step,
        slide: function (event, ui) {
            vram.val(ui.value);
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        },
        stop: function (event, ui) {
            if (parseInt(ui.value) < minram) {
                $("#sl_ram").slider("value", minram);
                vram.val(minram);
            }
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        }
    });
    vram.val(minram);
    $("#sl_ram").slider("value", minram);

    $("#sl_disk").slider({
        range: "min",
        value: mindisk,
        min: 0,
        max: maxdisk,
        step: disk_step,
        slide: function (event, ui) {
            vdisk.val(ui.value);
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        },
        stop: function (event, ui) {
            if (parseInt(ui.value) < mindisk) {
                $("#sl_disk").slider("value", mindisk);
                vdisk.val(mindisk);
            }
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        }
    });
    vdisk.val(mindisk);
    $("#sl_disk").slider("value", mindisk);

    var minVal = 0;
    if (maxbw == 0) {
        minVal = -1;
        vbw.css("color", "#FFFFFF");
    } else vbw.css("color", "#000000");
    $("#sl_bw").slider({
        range: "min",
        value: minbw,
        min: minVal,
        max: maxbw,
        step: bw_step,
        slide: function (event, ui) {
            vbw.val(ui.value);
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        },
        stop: function (event, ui) {
            if (parseInt(ui.value) < minbw) {
                $("#sl_bw").slider("value", minbw);
                vbw.val(minbw);
            }
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        }
    });
    vbw.val(minbw);
    $("#sl_bw").slider("value", minbw);

    if (minport == 0) minport = maxport;
    $("#sl_port").slider({
        range: "min",
        value: minport,
        min: 0,
        max: maxport,
        step: port_step,
        slide: function (event, ui) {
            vport.val(ui.value);
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        },
        stop: function (event, ui) {
            if (parseInt(ui.value) < minport) {
                $("#sl_port").slider("value", minport);
                vport.val(minport);
            }
            _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
        }
    });
    vport.val(minport);
    $("#sl_port").slider("value", minport);
    _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step);
}

function _pm_updatePrice(mincpu, cpu_price, cpu_step, minram, ram_price, ram_step, mindisk, disk_price, disk_step, minbw, bw_price, bw_step, minport, port_price, port_step) {
    var snapshotMin = serviceData[0].sconfig.backup_snapshot == undefined ? 0 : parseInt(serviceData[0].sconfig.backup_snapshot);
    var fullBackupMin = serviceData[0].sconfig.backup_full == undefined ? 0 : parseInt(serviceData[0].sconfig.backup_full);
    var addSnapshot = parseInt(suwin.find("select[name='snapshot']").val());
    var addFullBackup = parseInt(suwin.find("select[name='full_backup']").val());
    
    addSnapshot = addSnapshot - snapshotMin;
    addFullBackup = addFullBackup - fullBackupMin;

    var bwPrice = 0.00;

    normalPrice = (parseFloat(vcpu.val()) - mincpu) * cpu_price / cpu_step;
    normalPrice += (parseFloat(vram.val()) - minram) * ram_price / ram_step;
    normalPrice += (parseFloat(vdisk.val()) - mindisk) * disk_price / disk_step;
    if (minbw > 0) bwPrice = (parseFloat(vbw.val()) - minbw) * bw_price / bw_step;
    if (minport > 0) normalPrice += (parseFloat(vport.val()) - minport) * port_price / port_step;
    if (addSnapshot > 0) normalPrice += addSnapshot * parseFloat(productData[0].pupgrade.snapshot_price);
    if (addFullBackup > 0) normalPrice += addFullBackup * parseFloat(productData[0].pupgrade.full_backup_price);
    if (normalPrice < 0) normalPrice = 0;

    finalPrice = (normalPrice + bwPrice) * productDiscount;

    suwin.find('input[name="muprice"]').val(finalPrice.toFixed(2) + ' ' + userData[0].currency + ' /' + getTimeCycleSuffix(0, timeCycle, 0));

    normalPrice = normalPrice * remainingTime + (remainingTime > 1 ? bwPrice * remainingTime : bwPrice);
    finalPrice = normalPrice * productDiscount;

    if (normalPrice > finalPrice) {
        suwin.find('.finalPrice').html('<strike>' + normalPrice.toFixed(2) + '</strike>&nbsp;&nbsp;&nbsp;' + finalPrice.toFixed(2) + ' ' + userData[0].currency + ' 帐户优惠(' + (productDiscount * 100 / 10) + '折)');
        suwin.find('.normalPrice').html('');
    }
    else suwin.find('.finalPrice').html('<strong>' + finalPrice.toFixed(2) + ' ' + userData[0].currency + '</strong>');

}

_pm_init();
